; moscAS.ASM
; Mosc Advanced Simulation 2.1
; Decodifica canales codificadas en SECA emulando una tarjeta original
; PIC16F876 or PIC16F876 + i2c EEPROM
; (c) 2001,2002 The Picc2rd Team 


		LIST        P=16F876, F=INHX8M
		include     "P16F876.inc"
		include     "versinfo.inc"

		ERRORLEVEL -224, -302, -202


		; Flags de configuracin
		__CONFIG	_BODEN_OFF & _CP_OFF & _WRT_ENABLE_ON & _PWRTE_OFF & _WDT_OFF & _XT_OSC & _DEBUG_OFF & _CPD_OFF & _LVP_OFF 
		__IDLOCS	0xFFFF


;#DEFINE SIMMODE

		constant	LenMAX		=	0xFF
		constant	RECORDMAX	=	0xB0

		cblock 0x20

EEDATA2
EEADRH2
EEADR2
CONTROL
		;Bit 0      Activado = Borrado de Bx en el siguiente reset
		;Bit 1      Activado = Leds en catodo comn
		;Bit 2      Activado = Usar eeprom externa
		;Bit 3      Activado = Proteccin de Actualizacin de Claves
		;Bit 4	Activado = Proteccin del PBM
		;Bit 5	Activado = AutoPPUA
		;Bit 6	Activado = Desactivar leds
		;Bit 7	Activado = No decrementa fichas

CONTROLA	;Bit 0	Activado = Modo single provider
		;Bit 1	    Activado = DECO sin MHW
		;Bit 2	    Activado = Ignorar chequeo fecha (nano 22 ins 40)
		;Bit 3	    Activado = No pedir PIN en taquillas
		;Bit 4	    Activado = Logs
		;Bit 5      Activado = 
		;Bit 6
		;Bit 7
COUNTER
DUMMY1
DUMMY2
DUMMY3
DUMMY4
FSR2

		endc

		cblock	0x2B

IC_CLA
IC_INS
IC_P1
IC_P2
IC_LEN
BUFFER:10
P1KEY		;provider al que pertenece la key
P2KEY		;indice de la key
TEMP:8
LEDS
CONTROL2	;Bit 0  Activado = Actualizar clave secundaria
		;Bit 1	LastIns error    
		;Bit 2  Flag de registro no encontrado
		;Bit 3  Flag modo programacin se habilitan las instrucciones de actualizacin
		;Bit 4  proteccin de compra
		;Bit 5  Activo   = Capturar comando
		;Bit 6  Activado = No se ha encontrado EEPROM externa
		;Bit 7	(internal USE for nano 23/24/26)

EcmEMM_CONTROL	;Bit 0  Preview (ins 3c)    
		;Bit 1	
		;Bit 2  
		;Bit 3  6d00    
		;Bit 4	9015
		;Bit 5	(internal USE)
		;Bit 6	9009
		;Bit 7	97xx

C34DATA:3	; Para guardar el comando de la Instr_34, y de las 3C nano 31
C38DATA:3	; Para guardar el comando de la Instr_38, 
NANOCNT		; Cuenta num de nanos en ins 3c/40
reg80		;contiene estado de protecciones
NANOBitmap	; Cuenta num de nanos en ins 3c/40 por STATUSBYTE 97xx
PREVINS		; Instruccion anterior
REC1
REC2
REC3
KeyIndex
DESCByte	;Bit	0	8x-Cx
		;Bit	1	9x
		;Bit	2	Ax
		;Bit	3	Bx
		;Bit	4	Dx
		;Bit	5	Ex
		;Bit	6
		;Bit	7	Usado por la 32 34 para marcar un previo seca PPV Record
ChkSum
COUNTER2
nano27DATE:2
DUMMY5
DUMMY6
REGISTROS
CONTROL3	;bit	0	activado captura respuesta
LEEADRH2
LEEADR2
LDUMMY7
LDUMMY8
		endc


;Banco 1: Datos accesibles directamente con FSR
		cblock	0xA0

PK:8
SK:8
KEYTMP:10

		endc


cbank0          MACRO
                bcf     PCLATH,3
                bcf     PCLATH,4
		ENDM

cbank1          MACRO
                bsf     PCLATH,3
                bcf     PCLATH,4
		ENDM

cbank2          MACRO
                bcf     PCLATH,3
                bsf     PCLATH,4
		ENDM

cbank3          MACRO
                bsf     PCLATH,3
                bsf     PCLATH,4
		ENDM

cbankx		MACRO  nbank
	IF (nbank&1)!=0
		bsf     PCLATH,3
	ELSE
		bcf     PCLATH,3
	ENDIF
	IF (nbank&2)!=0
		bsf	PCLATH,4
	ELSE
		bcf	PCLATH,4
	ENDIF
	ENDM

;Macros para hacer llamadas y saltos entre bancos

xcall	MACRO adest
	cbankx #v(adest>>.11)
	errorlevel -306
	call   adest
	errorlevel +306
	cbankx #v($>>.11)
	ENDM

xgoto	MACRO  adest
	cbankx #v(adest>>.11)
	errorlevel -306
	goto   adest
	errorlevel +306
	ENDM

xcall10	MACRO	adest
        bcf     PCLATH,3
	errorlevel -306
	call   adest
	errorlevel +306
	bsf	PCLATH,3
	ENDM	

xcall01	MACRO	adest
        bsf     PCLATH,3
	errorlevel -306
	call   adest
	errorlevel +306
	bcf	PCLATH,3
	ENDM	

xgoto01	MACRO  adest
        bsf     PCLATH,3
	errorlevel -306
	goto   adest
	errorlevel +306
	ENDM

xgoto10	MACRO  adest
        bcf     PCLATH,3
	errorlevel -306
	goto   adest
	errorlevel +306
	ENDM

cbankset   	MACRO	nbank
	errorlevel -306
	cbankx	nbank
	ENDM

cbankreset 	MACRO
	cbankx	$>>.11
	errorlevel +306
	ENDM

cbank10          MACRO
	errorlevel -306
        bcf     PCLATH,3
	ENDM

cbank01          MACRO
        bsf     PCLATH,3
	errorlevel +306
	ENDM

;Macros de aritm'etica
;Rutinas de aritm'etica en 16 bits
;DH:DL+=SH:SL
Add16		MACRO	DH,DL,SH,SL
		movf	SL,w
		addwf	DL,f
		btfsc	STATUS,C
		incf	DH,f
		movf	SH,w
		addwf	DH,f
		ENDM

;DH:DL-=SH:SL
Sub16		MACRO	DH,DL,SH,SL
		movf	SL,w
		subwf	DL,f
		btfss	STATUS,C
		decf	DH,f
		movf	SH,w
		subwf	DH,f
		ENDM

;O1=O1H:O1L O2=O2H:O2L
;Res: si O1=O2 -> Z=1 & C=1
;     si O1>O2 -> Z=0 & C=1
;     si O1<O2 -> Z=0 & C=0
Cmp16		MACRO	O1H,O1L,O2H,O2L
		LOCAL	cmp16end
		movf	O2H,w
		subwf	O1H,w
		btfss	STATUS,C
		goto	cmp16end	;<
		btfss	STATUS,Z
		goto	cmp16end	;>
		movf	O2L,w
		subwf	O1L,w
cmp16end				;<,=,>
		ENDM

;DH:DL+=w
Addi16		MACRO	DH,DL
		addwf	DL,f
		btfsc	STATUS,C
		incf	DH,f
		ENDM

;DH:DL-=w
Subi16		MACRO	DH,DL
		subwf	DL,f
		btfss	STATUS,C
		decf	DH,f
		ENDM		


;Res: si O1=O2 -> Z=1 & C=1
;     si O1>O2 -> Z=0 & C=1
;     si O1<O2 -> Z=0 & C=0
Cmp16i		MACRO	O1H,O1L,VI16
		LOCAL	cmp16iend
		movlw	HIGH(VI16)
		subwf	O1H,w
		btfss	STATUS,C
		goto	cmp16iend	;<
		btfss	STATUS,Z
		goto	cmp16iend	;>
		movlw	LOW(VI16)
		subwf	O1L,w
cmp16iend				;<,=,>
		ENDM


; Para aprovechar las 8K del 876 y minimizar el tener que estar cambiando el valor de PCLATH se ha partido
; la memoria del program en 4 bloques de 2K (el 876 direcciona 2K sin necesidad de utilizar PCLATH)
; Banco 0 - PCLATH = 00 ( 00000 ) - 0000/7FFF
;	rutinas genericas acceso a memoria y puerto serie, encryptacion y desencriptacion de SECA
;	y algunos comandos que no caben.
; Banco 1 - PCLATH = 08 ( 01000 ) - 0800/0FFF
; Banco 2/3 	 = Flash MEMORY - 1000/1FFF
;	1e00/1eFF - Tabla 1 de Seca
;	1f00/1fFF - Tabla 2 de SECA

;-------------------------------------------------------------------------------
; Boot vector
;-------------------------------------------------------------------------------
			ORG	0x0000	;Empieza el codigo aqui
		clrf    PCLATH
		movlw   0xF0
		tris    PORTA
		goto    Init
			ORG	0x0004	;Nos saltamos el vector de interrupcin
		retfie

		include	"memory.asm"
		include	"serie.asm"

;-------------------------------------------------------------------------------
; Boot operations
;-------------------------------------------------------------------------------
Init 		   
		movlw   0xF0
		movwf   PORTA 
		clrf    LEDS
		movlw   0x7F
		option			;Load OPTION register with 0x7f (PORT B pull-ups enabled)
		clrf    CONTROL2
		call    ResetKey        ;inicializa la cache de key

		movlw	LOW(BAUDRATE)
		call    Rd_eeprom       ;Leemos Configuracin envio trfico
		bsf     STATUS,RP0      ;Selects Bank 1
		movwf   SPBRG
		movf    SPBRG,F         ;Miramos si es cero
		bsf     TXSTA,TXEN
		bcf     STATUS,RP0      ;Back to Bank 0
		btfss   STATUS,Z
			bsf     RCSTA,SPEN

		movlw	LOW(CONFIGBYTE)	;Leemos el ConfigByte
		call    Rd_eeprom
		movwf   CONTROL
		movlw	LOW(CONFIGEX)	;Leemos CONTROLA
		call    Rd_eeprom
		movwf   CONTROLA

		call    i2c_test        ;Miramos si hay eeprom externa
		btfss   STATUS,C        ;Si la hay
			goto	Hay_ext_eeprom  ;no desactiva cosas
		bsf     CONTROL2,6      ;Marcamos el Flag 6
		bcf     CONTROL,2       ;Forzamos Flag Flash interna
		bcf	CONTROLA,4	;Desactiva el log
Hay_ext_eeprom
		movlw	0x0f			;Enciende todos los leds durante el ATR
		btfss   CONTROL,1		;Tipo de Led
			xorlw   0x0F
		btfss	CONTROL,6		;leds desactivados
		movwf   PORTA

		movlw	HIGH(DATE)
		movwf	nano27DATE
		movlw	LOW(DATE)
		movwf	nano27DATE+1
;Lee los bytes de ATR almacenados en la flash y los envia
		movlw	LOW(ATRDATA)
		movwf	EEADR2
		movlw   ATRLen		;Longitud del comando ATR
		movwf	IC_LEN
		call	EEPROM_send

;*****************************************
; Inicializa la variable registros, con el ltimo+1 registro usado
GetNumRecordMAX
		movlw	HIGH(LAST_RECORD-BASE_DATOS)
		movwf	EEADRH2
		movlw	LOW(LAST_RECORD)
		movwf	EEADR2
		call	Rd_Memory
		movwf	REGISTROS
		xgoto01	SECA_Init                     

;**************************************************************************************************
;Rutinas del manejo de los punteros, para incremento y suma al puntero
;
;**************************************************************************************************
ADD_2pointer
		addwf	EEADR2,f
		btfsc	STATUS,C
			incf	EEADRH2,f
		return
INCR_pointer
		incf EEADR2,f
		btfsc	STATUS,Z
			incf	EEADRH2,f
		return

;**************************************************************************************************
;Envia la cadena de datos contenida en la FLASH del 876 a travs del puerto serie
;La direccin viene en EEADR2 la parte baja y en EEADRH2 la alta. En W est el nmero de bytes a enviar
;**************************************************************************************************
FLASH_send 
            movwf  	COUNTER
	    subwf   IC_LEN,w             ; pertenece a parte
            btfsc   STATUS,C             ; implementada de
            goto    FLASH_send_loop      ; la revisin 
            addwf   COUNTER,f            ; n 4 para el tema
            btfsc   STATUS,Z             ; la ins c1 12
            return

FLASH_send_loop
            movf    EEADR2,W
            call    Rd_Memory       ; lee dato
            incf    EEADR2,F
		btfsc	STATUS,Z
			incf	EEADRH2,f       ;hay acarreo: ajusta parte alta
		call    ChkSend        ; y lo enva
		decfsz	COUNTER,f
            goto    FLASH_send_loop
		return

;Envia una cadena contenida en flash
;EEADR2: parte baja de la direccion
;EEADRH2: parte alta
;W: longitud
PFLASH_send
		movwf	COUNTER
PF_send_loop
		call	Rd_PFlash
		call	ChkSend   		;Enviar byte
		call	INCR_pointer
		decfsz  COUNTER,f    
		goto    PF_send_loop
		return

;Envia una cadena contenida en RAM
;FSR: primer byte a enviar
;w: num bytes a enviar
RAM_send
		movwf	COUNTER           ; pertenece a 
		subwf   IC_LEN,w          ; a la revision
                btfsc   STATUS,C          ; n 4
                goto    RAM_send_loop     ;
                addwf   COUNTER,f         ;
                btfsc   STATUS,Z          ;
                return

RAM_send_loop
		movf	INDF,w
		call	ChkSend
		incf	FSR,f
		decfsz	COUNTER,f
		goto	RAM_send_loop
		return

;Envia una cadena contenida en EEPROM
;EEADR2: Dir inicial
;W:	num bytes
EEPROM_send
		movwf	COUNTER            ; aadido para la 
		subwf   IC_LEN,w           ; revisin n 4 
                btfsc   STATUS,C           ;
                goto    EEPROM_send_loop   ;
                addwf   COUNTER,f          ;
                btfsc   STATUS,Z           ;
                return

EEPROM_send_loop
		movf	EEADR2,w
		call	Rd_eeprom
		call	ChkSend
		incf	EEADR2,f
		decfsz	COUNTER,f
		goto	EEPROM_send_loop
		return

;Envia una cadena de FF hasta completar la longitud pedida
Send_FF
		movf	IC_LEN,f
		btfsc	STATUS,Z
			return
		movlw	0xff
		call	ChkSend
		goto	Send_FF
		

;*************************************************************************************

Swap8           call    Swap4
                goto    Swap4_1
Swap4           movwf   TEMP
Swap4_1         call    Swap1
                call    Swap1
                call    Swap1
Swap1           movf    TEMP,W
                movwf   FSR
                movf    INDF,W
                movwf   EEDATA2
                movf    EEADR2,W
                movwf   FSR
                movf    INDF,W
                movwf   DUMMY2
                movf    EEDATA2,W
                movwf   INDF
                movf    TEMP,W
                movwf   FSR
                movf    DUMMY2,W
                movwf   INDF       
                incf    EEADR2,f
                incf    TEMP,f
                return   
;*************************************************************************************
Move8           movwf   TEMP
                movlw   8
                movwf   TEMP+1
Move8_loop      movf    TEMP,w
                movwf   FSR
                movf    INDF,w
                movwf   EEDATA2
                movf    EEADR2,w
                movwf   FSR
                movf    EEDATA2,w
                movwf   INDF
                incf    TEMP,f
                incf    EEADR2,f
                decfsz  TEMP+1,f
                goto    Move8_loop
		movf    TEMP,w
                return                              

InitRECORDBuffer
		movlw	0x00

FillBuffer2
		movwf	BUFFER+8
		movwf	BUFFER+9
		movwf	BUFFER+0A
		movwf	BUFFER+0B
		movwf	BUFFER+0c
		movwf	BUFFER+0d
		movwf	BUFFER+0e
		movwf	BUFFER+0f

FillBuffer
                movwf  	BUFFER
                movwf  	BUFFER+1
                movwf  	BUFFER+2
                movwf  	BUFFER+3
                movwf  	BUFFER+4
                movwf  	BUFFER+5
                movwf  	BUFFER+6
                movwf   BUFFER+7		
		return

ClearBuffer
		movlw	0x00
		goto	FillBuffer	
;*************************************************************************
; Rellena un record con todos FF
; REC3:register of record to delete
FillRecord
		movfw	REC3
		btfsc	STATUS,Z
			return
		call	CalcRECORDAdr
		movlw	0x0C
		movwf	COUNTER
FillRecord_loop
		movlw	0xFF
		call	Wr_Memory
		call	INCR_pointer
		decfsz	COUNTER,f
		goto	FillRecord_loop
		goto	Max_REC_DEC

;*******************************************************
; Check if ProvID (xx W) exist
; if exist return 0x00 and IC_P1 = first provID empty, else return 0x02 and IC_P1 = 10 if doesn't exist
ChkIDENT
		movwf	TEMP+1
		movlw	0x10
		movwf	COUNTER
		clrf	IC_P1
ChkIDENT_loop
		call	CalcProvAdr
		addlw	0x01
        btfsc   STATUS,C
        incf    EEADRH2,f
		call	Rd_Memory
		xorwf	TEMP+1,W
		btfsc	STATUS,Z
			retlw	0x00
		incf	IC_P1,f
		decfsz	COUNTER,f
		goto	ChkIDENT_loop

		retlw	0x02

;**************************************************
; REC2 = Offset del record
; Devuelve EEADRH2:EEADR2 of REC2
; Devuelve en REC3 el Numero del record da richiamare
CalcProvRECORD
		call	CalcProvAdr
		addlw	0x18            ;Offset de RECORD Index
        btfsc   STATUS,C
        incf    EEADRH2,f
		addwf	REC2,w
		movwf	EEADR2
		btfsc   STATUS,C
			incf    EEADRH2,f
		call	Rd_Memory
		movwf	REC3		;Numero del record da richiamare

		return

;**************************************************************************************************
;* Calcula el offset en la FLASH del 876 de la key a utilizar
;* Devuelve en TEMP+0 el offset de la key y en EEADRH2 la pgina. 
CalcKeyAdr
		movfw	IC_P2
		andlw	0x0F
		addlw	PKEYSoffset
CalcKeyAdr2
		movwf	REC2

		call	CalcProvRECORD
		call	CalcRECORDAdr
 		movfw	EEADR2
		addlw	0x01
		movwf	TEMP+0
		return

;**************************************************************
; Incrementa y decrementa el puntero del ltimo registro en uso

Max_REC_DEC
		movfw	REGISTROS
		xorwf	REC3,w
		btfss	STATUS,Z
		return
		decf	REGISTROS,f
Max_REC_INC
Wr_REC_POINT	movlw	HIGH(LAST_RECORD-BASE_DATOS)
		movwf	EEADRH2
		movlw	LOW(LAST_RECORD)
		movwf	EEADR2
		movfw	REGISTROS
		goto	Wr_Memory


;**************************************************************
; Devuelve in REC3 the register of the first record empty
ChkRECORDFree
		incf	REGISTROS,f
		movlw	0x00

; Devuelve in REC3 the register of the record specified in W
SearchRECORD
		movwf	DUMMY1
		movfw	REGISTROS		;Max number of record
		movwf	COUNTER2
		clrf	REC3			;Begin from Record 01
SearchRECORD_next
		bcf	CONTROL2,2
		incf	REC3,f
		call	CalcRECORDAdr
		movlw	.11
		call	ADD_2pointer
SearchRECORD_loop
		movf	EEADR2,w
		call	Rd_Memory
		btfsc	DUMMY1,7
		goto	SearchRECORDNormal
		xorlw	0xff		;Buscar record libre
		btfsc	STATUS,Z	
		goto	SearchRecordFind		;Puede ser 0xff
		andlw	0x80
		btfss	STATUS,Z
		goto	SearchRecordFind	;Puede ser 0xxx xxxx 
		goto	SearchRecordContinue 
SearchRECORDNormal
		xorwf	DUMMY1,W
		btfsc	STATUS,Z
		goto	SearchRecordFind
SearchRecordContinue
		incf	REC3,f
		movlw	.12
		call	ADD_2pointer
		decfsz	COUNTER2,f
		goto	SearchRECORD_loop
		bsf	CONTROL2,2
		return
SearchRecordFind
		btfsc	DUMMY1,7
		return
		movfw	REC3
		xorwf	REGISTROS,w
		btfss	STATUS,Z
		decf	REGISTROS,f
		movfw	REC3
		sublw	RECORDMAX
		btfsc	STATUS,C
		goto	Max_REC_INC
		bsf	CONTROL2,2
		return
		
;**************************
NewRecord
		call	ChkRECORDFree

NewRecord_continue
		call	CalcProvAdr
		addlw	0x18			;Offset de RECORD Index
		addwf	REC2,W
		movwf	EEADR2
		btfsc	STATUS,C
			incf	EEADRH2,f
		movfw	REC3
		call	Wr_Memory

		btfsc		DESCByte,0
			goto	NewRecord8xCx
		btfsc		DESCByte,1
			goto	NewRecord9x
		btfsc		DESCByte,2
			goto	NewRecordEx

NewRecord8xCx
		call	CalcKeyAdr

		btfss	CONTROL2,0
			goto	NewRecord8x
		movlw	0x10
		addwf	IC_P2,W
		call	CalcKeyAdr2
NewRecord8x
		movfw	KeyIndex
		call	Wr_Memory				;scrivi il record INDEX
		movlw	0x0a
		call	ADD_2pointer
		movlw	0x00
		call	Wr_Memory
		call	INCR_pointer
		movfw	IC_P1
		andlw	0x0F
		btfsc	CONTROL2,0		;se  key secondaria
			iorlw	0xC0
		iorlw 0x80
		goto	Wr_Memory

NewRecord9x
		call	CalcPBMAdr
		movlw	0x08
		call	ADD_2pointer

		movlw	0x03
		movwf	COUNTER
Wr_Record9x_loop
		movlw	0x00
		call	Wr_Memory
		call	INCR_pointer
		decfsz	COUNTER,f
		goto	Wr_Record9x_loop

		movfw	IC_P1
		andlw	0x0F
		iorlw	0x90
		goto	Wr_Memory

NewRecordEx
		call	CalcRECORDAdr
		movlw	0x0B
		call	ADD_2pointer
		movfw	IC_P1
		andlw	0x0F
		iorlw	0xE0
		goto	Wr_Memory

;**************************************************************************************************
; Calcula el offset en la eeprom externa de los datos del proveedor especificado en IC_P1
; Devuelve el W el offset y en EEADRH2 la pgina
CalcProvAdr
		movlw	HIGH(PROV_INFO-BASE_DATOS)
                movwf   EEADRH2
                movf    IC_P1,W
                andlw   0x0F
                movwf   DUMMY2
                incf    DUMMY2,F
                movlw   LOW(PROV_INFO)
		goto	CalcProvAdr_1
CalcProvAdr_loop
                addlw   ProvINFOLen
                btfsc   STATUS,C
                incf    EEADRH2,f
CalcProvAdr_1
                decfsz  DUMMY2,f
                goto    CalcProvAdr_loop
                return

;**************************************************************************************************
; Calcula el offset en la eeprom externa del PBM del proveedor especificado en IC_P1
; Devuelve en EEADRH2:EEADR2

CalcPBMAdr
		movlw	0x01
		movwf	REC2
		call	CalcProvRECORD
		goto	CalcRECORDAdr

;**************************************************************
; Calcula el offset en la eeprom del RECORD specified in register REC3
; Devuelve en EEADRH2:EEADR2
CalcRECORDAdr
		clrf	EEADRH2
		movf	REC3,W
		movwf	EEADR2
		bcf	STATUS,C
		rlf	EEADR2,f
		rlf	EEADRH2,f
		rlf	EEADR2,f
		rlf	EEADRH2,f	;EEADRH2:EEADR2=REC3*4
		rlf	EEADRH2,w
		addwf	EEADRH2,f
		rlf	EEADR2,w
		btfsc	STATUS,C
		incf	EEADRH2,f	;Acarreo de la multiplicacion
		call	ADD_2pointer
					;(EEADRH2:EEADR2)+=(EEADRH2:EEADR2)*2
		movlw	LOW(RECORD-BASE_DATOS-.12)
		call	ADD_2pointer
		movlw	HIGH(RECORD-BASE_DATOS-.12)
		addwf	EEADRH2,f
		return


;*********************************************
CalcCHKSUM

		movfw	BUFFER+0
		addwf	BUFFER+1,W
		addwf	BUFFER+2,W
		addwf	BUFFER+3,W
		addwf	BUFFER+4,W
		addwf	BUFFER+5,W
		addwf	BUFFER+6,W
		addwf	BUFFER+7,W
		addwf	KeyIndex,W
		xorlw	0xff
		movwf	ChkSum

		return

;**************************************************************************************************
; Lee una key de la FLASH del 876. El offset viene en TEMP+0. Se almacena donde indica el registro indirecto
Get_key     
                movf    TEMP+0,W
                call    Rd_Memory
                movwf   INDF
                incf    FSR,f
                movlw   0x07            ;Leer 8 bytes
                movwf   TEMP+1             ;0x11 es el contador del bucle
Get_key_loop  
                call    Rd_Memory_Next
                movwf   INDF
                incf    FSR,f
                decfsz  TEMP+1,f
                goto    Get_key_loop
                return

;**************************************************************************************************
;Actualiza la fecha de suscripcin
UpdateDate
		call    CalcProvAdr
		addlw   0x16            ;Offset de la fecha
        btfsc   STATUS,C
        incf    EEADRH2,f
		movwf   EEADR2
		movlw	0x02
		call	LoadBuffer
		btfsc   CONTROL,3       ;No realizar si la proteccin de actualizaciones est activada
			return
		movlw	0x02
		goto	UpdateMem

;**************************************************************************************************
;Actualiza la clave primaria o secundaria
UpdateKey
		call    Restore
		movwf   KeyIndex
		andlw	0x0F
		movwf	IC_P2
		call    LoadBuffer8
		call    Decrypt
IsPrimKey
		call	CalcCHKSUM		;Calculate CHECKSUM Key
		bsf	DESCByte,0		;Next call to NewRecord write new 8xCx record

		movfw	IC_P2
		btfsc	CONTROL2,0
			addlw	0x10
		movwf	IC_P2
		addlw	PKEYSoffset
		xcall01	ChkRECORD
		xorlw	(0x00)
		btfss	STATUS,Z
			call	NewRecord
WriteKey
		call	CalcKeyAdr

		btfss	CONTROL2,0
			goto	WriteKey2
		movlw	0x10
		addwf	IC_P2,W
		call	CalcKeyAdr2
WriteKey2
		movfw	TEMP+0
		movwf	EEADR2
		btfsc	CONTROL,3       ;No realizar si la proteccin de actualizaciones est activada
			return
		call	UpdateMem8
		movfw	ChkSum
		movwf	BUFFER+0
		movlw	0x01
		call	UpdateMem		;Update CHKSUM Key
		goto	ResetKey        ;Recargar la key

;**************************************************************************************************
;* GET COMMAND HEADER                                                                             *
;**************************************************************************************************
GetCommandHeader
		call	Receive
		movwf	IC_CLA
		call	Receive
		movwf	IC_INS
		call	Receive
		movwf	IC_P1
		call	Receive
		movwf	IC_P2
		call	Receive
		movwf	IC_LEN
		return
;**************************************************************************************************
;* GET COMMAND DATA                                                                               *
;**************************************************************************************************
GetCommandData
		clrf	FSR2
		movf	IC_LEN,w
		btfsc	STATUS,Z		;0 bytes: no recibir nada
			return
		movwf	COUNTER
GetCmdData_loop 
		call	Receive
		call	Store
		decfsz	COUNTER,f
		goto	GetCmdData_loop
                return
;**************************************************************************************************
;* CHECK SIGNATURE                                                                                *
;**************************************************************************************************
CheckSignature
		movlw   0x08
		subwf   IC_LEN,W         ;Ajusta el numero de bytes que entran en la computacin
		movwf   COUNTER
		movwf   FSR2            ;Comprueba que el comando contenga el nano 82 de la
		decf    FSR2,F          ;firma 9 posiciones antes del final
		call    Restore
		xorlw   0x82
		btfss   STATUS,Z        
			retlw   0x01            ;Devuelve error (No hay firma)
Chk_signature	call    InitHashBuf     ;Inicializa el Hash Buffer
		clrf    FSR2
CheckSign_loop              
                call    XorBuffer
                call    keyloaded
                call    Encrypt
                movf    COUNTER,F
                btfss   STATUS,Z
                goto    CheckSign_loop
		btfsc	IC_INS,1
		retlw	0x03				

                bsf     LEDS,1          ;Activamos LED2 Clave Falsa
                movlw   BUFFER
                movwf   FSR
                movlw   0x08
                movwf   COUNTER
CheckSign_loop2
                call    Restore
                xorwf   INDF,W
                btfss   STATUS,Z
                retlw   0x02
                incf    FSR,F
                decfsz  COUNTER,F
                goto    CheckSign_loop2
                call    keyloaded        
                bcf     LEDS,1          ;Desactivamos LED2 Clave Falsa
                retlw   0x00
XorBuffer
		movlw   BUFFER
		movwf   FSR
XorBuffer_loop
		call    Restore
		xorwf   INDF,F
		decf    COUNTER,F
		btfsc   STATUS,Z
			return
		incf    FSR,F
		btfss   FSR,3           ;CUIDADO!!!
			goto    XorBuffer_loop
		return
InitHashBuf
		call	ClearBuffer	;Inicializa Hash Buffer a ceros

                movf    IC_P1,W
                andlw   0xE0
                movwf   DUMMY1
                xorlw   0x20
                btfsc   STATUS,Z
                goto    InitHashBuf1
                movf    DUMMY1,W
                xorlw   0x40
                btfsc   STATUS,Z
                goto    InitHashBuf2
                movf    DUMMY1,W
                xorlw   0x60
                btfsc   STATUS,Z
                goto    InitHashBuf3
InitHashBuf0                            ;Hash Buffer a ceros                
		return
InitHashBuf1                            ;Inicializa Hash Buffer a UA,0,0
		movlw	HIGH(TarjetaUA-BASE_DATOS)
		movwf   EEADRH2
		movlw   LOW(TarjetaUA)+2
		call    Rd_Memory
		movwf   BUFFER+0
		call    Rd_Memory_Next
		movwf   BUFFER+1
		call    Rd_Memory_Next
		movwf   BUFFER+2
		call    Rd_Memory_Next
		movwf   BUFFER+3
		call    Rd_Memory_Next
		movwf   BUFFER+4
		call    Rd_Memory_Next
		movwf   BUFFER+5
		return
InitHashBuf2                            ;Inicializa Hash Buffer a PPUA,0,0,0,0
                call    CalcProvAdr     ;Offset Provider Info
                addlw   0x12            ;Offset PPUA
                btfsc   STATUS,C
                incf    EEADRH2,f
                call    Rd_Memory
                movwf   BUFFER+0
                call    Rd_Memory_Next
                movwf   BUFFER+1
                call    Rd_Memory_Next
                movwf   BUFFER+2
                call    Rd_Memory_Next
                movwf   BUFFER+3
                return
InitHashBuf3                            ;Inicializa Hash Buffer a SA,0,0,0,0,0                  
                call    CalcProvAdr
                addlw   0x12
                btfsc   STATUS,C
                incf    EEADRH2,f
                call    Rd_Memory
                movwf   BUFFER+0
                call    Rd_Memory_Next
                movwf   BUFFER+1
                call    Rd_Memory_Next
                movwf   BUFFER+2
                return
;**************************************************************************************************
;* LOAD KEYS                                                                                      *
;**************************************************************************************************
LoadKeys
		call	CalcKeyAdr	;cargar key
		movlw	KEYTMP
		movwf	FSR
		call	Get_key         ;Carga la PK

		btfss	IC_P1,4
			goto	loadnew2
		movlw	0x10
		addwf	IC_P2,W
		addlw	PKEYSoffset
		call	CalcKeyAdr2
loadnew2
		call    Get_key         ;Carga la SK
		movlw   0x1f            ;Coloca los valores de la key cargada
		andwf   IC_P1,w
		movwf   P1KEY
		movlw   0x0f
		andwf   IC_P2,w
		movwf   P2KEY  

keyloaded	movlw   PK
		movwf   EEADR2
		movlw   KEYTMP
		call 	Move8
		goto 	Move8

ResetKey
		movlw   0xff
		movwf   P1KEY
		movwf   P2KEY
		return

;**************************************************************************************************
;* DECODE DATA IN SUPERENCRIPTION                                                                 *
;**************************************************************************************************
Decode
		btfss   IC_P2,7         ;Hay Supercriptacin?
			return                  ;Si NO -> volver
		movwf	FSR2
		call    keyloaded
		incf	FSR2,w
		subwf	IC_LEN,w
		btfss	STATUS,C
		return
		andlw   0xF8
		movwf   COUNTER
Decode_loop 
                movf    COUNTER,F
                btfsc   STATUS,Z
                return          
                call    LoadBuffer8
                call    Decrypt
                movlw   0x08    
                subwf   FSR2,F      
                subwf   COUNTER,F
                call    StoreBuffer8
                goto    Decode_loop                   

;Obtiene la direccion de lestura/escritura y la deja en EEADRH2:EEADR2
;Si la operacion es sobre la eeprom interna se devuelve Z=1
GetAddr
		movf    IC_P2,W         ;P2: Parte baja
		movwf	EEADR2
		movf    IC_P1,W		;P1: Parte alta de la direccin a leer
		movwf	EEADRH2
		btfss	EEADRH2,7
		goto	GetAddrEnd
		bcf	STATUS,C
		rlf	EEADR2,f
		rlf	EEADRH2,f
GetAddrEnd
		xorlw	0x21
		return

;***********************************************************************
;Lee un bloque de datos de la FLASH del 876 si P1 = 21h lee de la eeprom
;***********************************************************************
Ldr_RdMem
		call	GetAddr
		btfsc   STATUS,Z
		goto    Instr_20E

		movf	IC_LEN,W
		goto	FLASH_send
Instr_20E
		movf    IC_LEN,W
		goto    EEPROM_send

;*********************************************************************************
;* Escribe un bloque de datos en la FLASH del 876 si P1 = 21h escribe en la eeprom
;*********************************************************************************
Ldr_WrMem
                call    GetCommandData
                clrf    FSR2
		call	GetAddr
		btfsc	STATUS,Z
		goto	Instr_22E
instr_22_loop  
                call    Restore            ;Recibe un byte
                call	Wr_Memory
		call	INCR_pointer
                decfsz  IC_LEN,F
                goto    instr_22_loop
		return
Instr_22E
                call    Restore
                call    Wr_eeprom   
                incf    EEADR2,F
                decfsz  IC_LEN,F
                goto    Instr_22E
		return

;***********************************************
;* Leer la Flash de Programa    
;* P1:P2    Direccion
;* P3       Longitud
;***********************************************
Ldr_RdFlash
                movf    IC_P1,W         ;P1: Parte alta de la direccin a leer
                movwf   EEADRH2
                movf    IC_P2,W         ;P2: Parte baja
                movwf   EEADR2
instr_24_loop  
                call    Rd_PFlash       ;Lee valor de la Flash del 876
                bsf     STATUS,RP1      ;Select Bank 2
                movf    EEDATH,W
                bcf     STATUS,RP1      ;Back to Bank 0
                call    ChkSend         ;Y lo enva  
                bsf     STATUS,RP1      ;Select Bank 2
                movf    EEDATA,W
		bcf     STATUS,RP1      ;Back to Bank 0
		call    ChkSend         ;Y lo enva  
		call	INCR_pointer
		movf	IC_LEN,f
		btfss	STATUS,Z      
                goto    instr_24_loop
		return

;***********************************************
;* Escribir en la Flash de Programa
;* P1:P2    Direccion
;* P3       Longitud
;***********************************************
Ldr_WrFlash
		call    GetCommandData
		movf    IC_P1,W
		movwf   EEADRH2
		movf    IC_P2,W
		movwf   EEADR2
		clrf    FSR2
		rrf     IC_LEN,F
instr_26_loop  
		call    Restore         ;Recibe un byte
		bsf     STATUS,RP1      ;Select Bank 2
		movwf   EEDATH
		bcf     STATUS,RP1      ;Back to Bank 0
		call    Restore         ;Recibe un byte
		bsf     STATUS,RP1      ;Select Bank 2
		movwf   EEDATA
		bcf     STATUS,RP1      ;Back to Bank 0
		call	Wr_PFlash
		call	INCR_pointer
		decfsz  IC_LEN,F
		goto    instr_26_loop
		return

;Guarda un bloque de datos en Buffer comparando.
;EEADRH2:EEADR2 Dir. inicial a comparar
;w: Num de datos a comparar
UpdateMem8	movlw	0x08
UpdateMem	
		movwf	TEMP+7
		movlw	BUFFER
		movwf	FSR
UpdateMemLoop
		movf	EEADR2,w
		call	Rd_Memory
		xorwf	INDF,w
		btfsc	STATUS,Z
			goto	NoMemChange
		movf	INDF,w
		call	Wr_Memory
		btfss	IC_INS,6
		goto	NoMemChange
		bsf	EcmEMM_CONTROL,5	;habilita bit 5 ( UpdateMem OK )
		bsf     LEDS,3          ;Activa el LED 3
NoMemChange
		incf	FSR,f
		call	INCR_pointer
		decfsz	TEMP+7,f
		goto	UpdateMemLoop
		return

;**************************************************************************************************
;* LOAD BUFFER                                                                                    *
;**************************************************************************************************
LoadBuffer8	movlw	0x08
LoadBuffer	movwf	TEMP+7
                movlw   BUFFER
                movwf   FSR
LoadBuffer_loop
                call    Restore
                movwf   INDF
                incf    FSR,F
                decfsz	TEMP+7,f           
                goto    LoadBuffer_loop
                return

;**************************************************************************************************
;* STORE BUFFER                                                                                   *
;**************************************************************************************************
StoreBuffer8	movlw	0x08
StoreBuffer
		movwf	TEMP+7
                movlw   BUFFER
                movwf   FSR
StoreBuffer_loop
                movf    INDF,W
                call    Store
                incf    FSR,F
                decfsz	TEMP+7,f          
                goto    StoreBuffer_loop
                return

;**************************************************************************************************
;* STORE W->[FSR2] max 0x60 bytes                                                                            *
;**************************************************************************************************
Store
                movwf   0x7F
                movf    FSR,W
                movwf   0x7E		
		movlw	0x90
		addwf	FSR2,w
		movwf	FSR
                bsf     STATUS,IRP
                movf    0x7F,W
                movwf   INDF
                bcf     STATUS,IRP
                incf    FSR2,F
                movf    0x7E,W
                movwf   FSR
                movf    0x7F,W
                return

;**************************************************************************************************
;* RESTORE [FSR2]->W max 0x60 bytes                                                               *
;**************************************************************************************************
Restore
                movf    FSR,W
                movwf   0x7E
                movlw   0x90
                addwf   FSR2,W
                movwf   FSR
                bsf     STATUS,IRP
                movf    INDF,W
                movwf   0x7F
                bcf     STATUS,IRP
                incf    FSR2,F
                movf    0x7E,W
                movwf   FSR
                movf    0x7F,W
                return
;******************************************************
;Devuelve DUMMY1:DUMMY2 = Bitmap of supported providers
ReadI16_ANS
		movlw	HIGH	(I16_ANS-BASE_DATOS)
		movwf	EEADRH2
		movlw	LOW	(I16_ANS)+2
		call	Rd_Memory
		movwf	DUMMY1
		call	Rd_Memory_Next
		movwf	DUMMY2
		call	Rd_Memory_Next
		movwf	DUMMY3
		btfss	CONTROL2,3
		btfss	CONTROLA,0
		return
		movlw	low(SINGLEMASK)
		call    Rd_eeprom
		andwf	DUMMY1,f
		movlw	low(SINGLEMASK+1)
		call    Rd_eeprom
		andwf	DUMMY2,f
		return

;***********************
; Check Provider Routine
;***********************
Chk_Provider
		call	ReadI16_ANS
		movf	DUMMY2,w
Chk_Mask	btfsc	IC_P1,3
		movf	DUMMY1,w
		movwf	TEMP+0
		movf	IC_P1,w
		andlw	0x07
		call	GetBitMask
		bcf	STATUS,C
		andwf	TEMP+0,w
		btfss	STATUS,Z
		bsf	STATUS,C
		return
;***************************************
RESET_PROVIDER

;cancella tutti i record relativi al provider specificato in IC_P1
DeleteALLRecord		
		movlw	0x01
		movwf	REC2
DeleteALLRecord_loop
		call	CalcProvRECORD
		call	FillRecord
		incf	REC2,f
		movfw	REC2
		xorlw	(0x30)
		btfss	STATUS,Z
			goto	DeleteALLRecord_loop

;cancella tutte le info relative al provider specificato in IC_P1
DeleteALLProviderINFO
		call	CalcProvAdr
		movwf	EEADR2
		movlw	0x4B
		movwf	COUNTER

DeleteALLProviderINFO_loop
		movlw	0xFF
		call	Wr_Memory
		call	INCR_pointer
		decfsz	COUNTER,f
		goto	DeleteALLProviderINFO_loop

		goto	DecfINS16_ANS

;*********************************************
NEW_PROVIDER
		call	CalcProvAdr
		movwf	EEADR2
		movlw	0x00
		call	Wr_Memory
		call	INCR_pointer
		movfw	BUFFER+1		; Prov_ID
		call	Wr_Memory
		movlw	0x10
		call	ADD_2pointer
;		movwf	EEADR2	
		call	ClearBuffer
		movlw	0x07
		movwf	COUNTER
INIT_ProvINFO_loop
		call	UpdateMem8
		decfsz	COUNTER,f
		goto	INIT_ProvINFO_loop
		movlw	0x02
		call	UpdateMem

IncfINS16_ANS
		call	ReadI16_ANS
		movf	IC_P1,w
		andlw	0x07
		call	GetBitMask
		btfsc	IC_P1,3
		goto	IncfINS16_ANS2
		iorwf	DUMMY2,f
		return
IncfINS16_ANS2
		iorwf	DUMMY1,f
		return

DecfINS16_ANS
		call	ReadI16_ANS
		movf	IC_P1,w
		andlw	0x07
		call	GetBitMask
		xorlw	0xff
		btfsc	IC_P1,3
		goto	DecfINS16_ANS2
		andwf	DUMMY2,f
		return
DecfINS16_ANS2
		andwf	DUMMY1,f
		return

;****************************
SendRecord_view
		call	CalcRECORDAdr

		movlw	0xD2
		call	Store
		movlw	0x00
		call	Store
		movfw	REC3
		call	Store

		movlw	0x0C
		call	Store_RECORD
DumpRecords_2
		movlw	0x00
		call	Store
		movlw	0x00
		call	Store
		movlw	0x03
		call	Store

		incf	C34DATA+2,f
		movfw	C34DATA+2
		movwf	DUMMY1		;ultimo byte trasmesso +1

		return
;----------------------------------------------------------------------------
SendRecord_hide
		call	CalcRECORDAdr
		movlw	0xD2
		call	Store	;call	ChkSend
		movlw	0x00
		call	Store	;call	ChkSend
		movfw	REC3
		call	Store	;call	ChkSend
		movfw	EEADR2
		call	Rd_Memory
		call	Store	;call	ChkSend

		movlw	0x08
		movwf	COUNTER
DumpKey_loop
		movlw	0xFF
		call	Store	;call	ChkSend
		decfsz	COUNTER,f
		goto	DumpKey_loop

		movfw	EEADR2
		addlw	0x09
		movwf	EEADR2
		btfsc	STATUS,C
			incf	EEADRH2,f
		movlw	0x03
		call	Store_RECORD	;call	FLASH_send
		
		goto	DumpRecords_2



;Routinas de encriptacin y desencriptacion de SECA

;**************************************************************************************************
;Rutina de encriptacin SECA
;DUMMY3 es i apunta al elemento de la key que se est procesando (0x00..0x0f)
;DUMMY1 es la constante C
;BUFFER[8] contiene los datos a encriptar
;PK[8],SK[8] contiene la clave primaria y secundaria respectivamente
;**************************************************************************************************
Encrypt
                clrf    DUMMY1          ;C=0
                clrf    DUMMY3          ;i=1
Encrypt_round       
                call    InitKey         ;K[i]=K[i] XOR T1[K[i+1] XOR K[i-1] XOR C]
                incf    DUMMY3,f        ;i=i+1
                call    InitKey         ;K[i]=K[i] XOR T1[K[i+1] XOR K[i-1] XOR C]
                incf    DUMMY3,f        ;i=i+1
                call    InitKey         ;K[i]=K[i] XOR T1[K[i+1] XOR K[i-1] XOR C]
                incf    DUMMY3,f        ;i=i+1
                call    InitKey         ;K[i]=K[i] XOR T1[K[i+1] XOR K[i-1] XOR C]
                movlw   3
                subwf   DUMMY3,f        ;i=i-3
                call    crypt1
                incf    DUMMY3,f        ;i=i+1
                call    crypt2
		movfw	DUMMY1		;C -> W
		xorlw	0x0F            ;
		btfsc	STATUS,Z        ;Si C=15 retornar 
			return                  ;Encriptacin terminada
                movlw   BUFFER
                movwf   EEADR2
                movlw   BUFFER+4
                call	Swap4           ;Swap de d[0]..d[3] con d[4]..d[7]
                incf    DUMMY1,f        ;C=C+1
                btfsc   DUMMY3,4        ;Si i>15
                clrf    DUMMY3          ;i=0
                goto    Encrypt_round   ;Siguiente iteracin

;**************************************************************************************************
;Rutina para desencriptar SECA
;DUMMY3 apunta al elemento de la key que se est procesando (0x00..0x0f)
;DUMMY1 es la constante C
;BUFFER[8] contiene los datos a encriptar
;PK[8],SK[8] contiene la clave primaria y secundaria respectivamente
;**************************************************************************************************
Decrypt     
		clrf	DUMMY3
		clrf	DUMMY1

; Preparacion de las claves
Decrypt_loop
		call	InitKey		;K[i]=K[i] XOR T1[K[i-1] XOR K[i+1] XOR C]
		incf	DUMMY3,f		;i=i+1 
		movfw	DUMMY3
		andlw	0x03
		btfsc	STATUS,Z
			incf    DUMMY1,f	;Cada 4 iteraciones del bucle incrementa la constante C
		btfss	DUMMY3,6
			goto    Decrypt_loop	;Hacer 16*4 iteraciones

		movlw	0x0F			;\ Constant "C" is initially set to the value 0x0F (15)
		movwf	DUMMY1		;/
		movlw	0x0C			;\ i=13 (13th key element)
		movwf	DUMMY3		;/ so the index in 0..15 (0x00..0x0F) is 12 (0x0C)

Decrypt_round       
		call	crypt1
		call	crypt2

;prepare keys for the next iteration
		call	InitKey		;K[i]=K[i] XOR T1[K[i+1] XOR K[i-1]]
		decf	DUMMY3,F		;i=i-1
		call	InitKey		;K[i]=K[i] XOR T1[K[i+1] XOR K[i-1]]
		decf	DUMMY3,F		;i=i-1
		call	InitKey		;K[i]=K[i] XOR T1[K[i+1] XOR K[i-1]]
		decf	DUMMY3,F		;i=i-1
		call	InitKey		;K[i]=K[i] XOR T1[K[i+1] XOR K[i-1]]
		movf	DUMMY1,F
		btfsc	STATUS,Z		;Si C=0 retornar
			return

;another iteration is needed, swap nibbles and decrement C
		movlw	BUFFER
		movwf	EEADR2
		movlw	BUFFER+4
		call	Swap4			;Swap d[0]..d[3] with d[4]..d[7]
		decf	 DUMMY1,f		;C=C-1
		movlw	0xFC
		addwf	DUMMY3,f		;i=i-4
		movlw	0x0C			;\
		btfsc	DUMMY3,7		;If i<0 set i again to 12 (0x0C)
			movwf	DUMMY3	;/
		goto	Decrypt_round

;**************************************************************************************************
crypt1
		call	ekey			;Read K[i] and store it into W
		xorwf	BUFFER+4,W		;W=d[4] XOR K[i]
		call	Tabla1
		movwf	TEMP+0		;TEMP+0=T1[W]
		incf	DUMMY3,F		;i=i+1
		call	ekey			;Read K[i] and store it into W
		xorwf	BUFFER+5,W		;W=d[5] XOR K[i]
		call	Tabla1
		movwf	TEMP+1		;TEMP+1=T1[W]
		incf	DUMMY3,F		;i=i+1
		call	ekey			;Read K[i] and store it into W
		xorwf	BUFFER+6,W		;W=d[6] XOR K[i]
		call	Tabla1
		movwf	TEMP+2		;TEMP+2=T1[W]
		incf	DUMMY3,F		;i=i+1
		call	ekey			;Read K[i] and store it into W
		xorwf	BUFFER+7,W		;W=d[7] XOR K[i]
		call	Tabla1
		movwf	TEMP+3		;TEMP+3=T1[W]
		return
;**************************************************************************************************
crypt2              
		xorwf   TEMP+0,f        ;d5=d5 XOR d8
		swapf   TEMP+3,W
		addwf   TEMP+2,W        ;W=~d8+d7 
		call    Tabla2          ;W=T2[W]
		movwf   TEMP+2          ;TEMP+2=T2[W]
		xorwf   TEMP+3,f        ;d[7]=d[7] XOR d[6]
		swapf   TEMP+2,W
                addwf   TEMP+1,W
                call    Tabla2
                movwf   TEMP+1          ;d[5]=T2[~d[6]+d[5]]
                xorwf   TEMP+2,f        ;d[6]=d[6] XOR d[5]
                swapf   TEMP+1,W
                addwf   TEMP+0,W
                call    Tabla2
                movwf   TEMP+0              ;d[4]=T2[~d[5]+d[4]]
                xorwf   TEMP+1,f            ;d[5]=d[5] XOR d[4]
                swapf   TEMP+0,W
                addwf   TEMP+3,W
                call    Tabla1
                movwf   TEMP+3              ;d[7]=T1[~d[4]+d[7]]
                xorwf   TEMP+0,f            ;d[4]=d[4] XOR d[7]
                swapf   TEMP+3,W
                addwf   TEMP+2,W
                call    Tabla1
                movwf   TEMP+2              ;d[6]=T1[~d[7]+d[6]]
                xorwf   TEMP+3,f            ;d[7]=d[7] XOR d[6]
                swapf   TEMP+2,W
                addwf   TEMP+1,W
                call    Tabla1
                movwf   TEMP+1              ;d[5]=T1[~d[6]+d[5]]
                xorwf   TEMP+2,f            ;d[6]=d[6] XOR d[5]
                movf    TEMP+0,W
                xorwf   TEMP+1,f            ;d[5]=d[5] XOR d[4]

                movf    TEMP+1,W
                call    Tabla2
                xorwf   BUFFER+0,f      ;d[0]=d[0] XOR T2[d[5]]
                movf    TEMP+3,W
                call    Tabla2
                xorwf   BUFFER+1,f      ;d[1]=d[1] XOR T2[d[7]]
                movf    TEMP+0,W
                call    Tabla2
                xorwf   BUFFER+2,f      ;d[2]=d[2] XOR T2[d[4]] 
                movf    TEMP+2,W
                call    Tabla2
                xorwf   BUFFER+3,f      ;d[3]=d[3] XOR T2[d[6]]
                return
;**************************************************************************************************
;* K[i]=K[i] XOR T1[K[i-1] XOR K[i+1] XOR C]
InitKey       
		incf    DUMMY3,W
		call    ekeyW
		movwf   DUMMY2          ;K[i+1]
		decf    DUMMY3,W
		call    ekeyW    
		xorwf   DUMMY2,f        ;K[i+1] XOR K[i-1]
		call    ekey            ;No usa el resultado, pero hace que FSR apunte al elemento indicado por 0x0f
		movf    DUMMY2,W   
		xorwf   DUMMY1,W        ;K[i+1] XOR K[i-1] XOR C
		call    Tabla1          ;T1[K[i+1] XOR K[i-1] XOR C]
		xorwf   INDF,f          ;K[i]=K[i] XOR T1[K[i+1] XOR K[i-1] XOR C]
		return
;**************************************************************************************************
;* W = K[i]
ekey        
		movf    DUMMY3,W        ;i -> W
ekeyW       
		andlw   0x0F            ;Devuelve el elemento apuntado en W. El AND controla el wrap (por si el indice mayor de 0x0f)
		addlw   PK              ;La key est almacenada en PK
		movwf   FSR
		movf    INDF,W
		return

;**************************************************************************************************
;Devuelve el valor de Tabla1 del algoritmo de SECA que corresponde al valor contenido en W
Tabla1  
		cbankset 3    
		call    Tabla12
		clrf	PCLATH
		return

;**************************************************************************************************
;Devuelve el valor de Tabla2 del algoritmo de SECA que corresponde al valor contenido en W
Tabla2
		cbankset 3
		call    Tabla22
		clrf	PCLATH
		return


;*************************************************************************
; w-> numero de bytes a volcar en fsr2
Store_RECORD
		movwf	TEMP+1
		movfw	EEADR2
		call	Rd_Memory
		call	Store
		decf   TEMP+1,f
Store_RECORD_loop
		call    Rd_Memory_Next
		call	Store
		decfsz  TEMP+1,f
		goto	Store_RECORD_loop
		return
;**************************************************************************             
;Comandos de remoto
;DUMMY4: comando de remoto
Instr_30_Especial
		movlw	0xe0
		andwf	DUMMY4,w
		xorlw	0x80
		btfss	STATUS,Z
		retlw	0x00
;Comando tipo cambio bit de control
; 100A BBBC
; A: byte de control a modificar
; BBB: bit a modificar
; C: nuevo valor

		clrf	DUMMY1		
		clrf	DUMMY2
		rrf	DUMMY4,w
		andlw	0x07
		call	GetBitMask
		btfss	DUMMY4,0
		movwf	DUMMY1
		btfsc	DUMMY4,0
		movwf	DUMMY2
		movlw	0xff
		xorwf	DUMMY1,f
		movf	CONTROL,w
		btfsc	DUMMY4,4
		movf	CONTROLA,w
		andwf	DUMMY1,w
		iorwf	DUMMY2,w
		btfsc	DUMMY4,4
		goto	Modif_controlA
		movwf	CONTROL
wr_control	movlw	LOW(CONFIGBYTE)
		movwf	EEADR2
		movf	CONTROL,w	
		call	Wr_eeprom
		retlw	0x10
Modif_controlA
		movwf	CONTROLA
		movlw	LOW(CONFIGEX)
		movwf	EEADR2
		movf	CONTROLA,w	
		call	Wr_eeprom
		retlw	0x10


GetBitMask
		andlw	0x07
		addlw	LOW(BITTBL)
		goto    Rd_eeprom

;**************************************************************
process_AX				;controlar Ax Dummy1 y Dummy2 tienen el evento, nano27date la fecha,DUMMY3 el contador
		movfw	DUMMY3
		movwf	C34DATA
		movfw	C34DATA+1
		movwf	DUMMY5
		movfw	C34DATA+2
		movwf	DUMMY6
		call	CheckAx
		movwf	DUMMY5
		xorlw	(0x00)
		btfss	STATUS,Z
			goto	hay_AX
		clrf	DUMMY5
		clrf	DUMMY6
		call	CheckAx
		movwf	DUMMY5
		xorlw	(0x00)
		btfss	STATUS,Z
			goto	hay_AX
		call	ChkRECORDFree
		btfsc	CONTROL2,2
			retlw	0x03		;Superado numero maximo de registros (9003)
		call	InitRECORDBuffer		;Clear BUFFER[00..0B]
		movfw	nano27DATE
		movwf	BUFFER
		movfw	nano27DATE+1
		movwf	BUFFER+1
		movlw	0x01
		movwf	DUMMY5
		movfw	C34DATA+1
		movwf	BUFFER+2
		movfw	C34DATA+2
		movwf	BUFFER+3
hay_AX		btfss	DUMMY5,0
		goto	hay_ax2
		movfw	C34DATA+1
		movwf	BUFFER+2
		movfw	C34DATA+2
		movwf	BUFFER+3
		decf	BUFFER+4,f
		btfsc	STATUS,Z
			goto	Ax_to_Bx
		movlw	0xFF
		xorwf	BUFFER+4,w
		btfss	STATUS,Z
			goto	write_ax
		movfw	C34DATA
		movwf	BUFFER+4
		goto	write_ax
hay_ax2
		btfss	DUMMY5,1
			goto	hay_ax3
		movfw	C34DATA+1
		movwf	BUFFER+5
		movfw	C34DATA+2
		movwf	BUFFER+6
		decf	BUFFER+7,f
		btfsc	STATUS,Z
		goto	Ax_to_Bx
		movlw	0xFF
		xorwf	BUFFER+7,w
		btfss	STATUS,Z
			goto	write_ax
		movfw	C34DATA
		movwf	BUFFER+7
		goto	write_ax
hay_ax3
		movfw	C34DATA+1
		movwf	BUFFER+8
		movfw	C34DATA+2
		movwf	BUFFER+9
		decf	BUFFER+0A,f
		btfsc	STATUS,Z
			goto	Ax_to_Bx
		movlw	0xFF
		xorwf	BUFFER+0A,w
		btfss	STATUS,Z
			goto	write_ax
		movfw	C34DATA
		movwf	BUFFER+0A
write_ax
		movfw	IC_P1
		andlw	0x0F
		iorlw	0xA0
		movwf	BUFFER+0B
		movfw	REC3
		call	CalcRECORDAdr		;EEADRH2:EEADR2 Address of first record free
		movlw	0x0C
		call	UpdateMem
		retlw	0x00

CheckAx
		movfw	IC_P1
		andlw	0x0F
		iorlw	0xA0
		call	SearchRECORD
Chk_Ax_loop
		btfsc	CONTROL2,2
			goto	ax_dontexist
		call	CalcRECORDAdr
		xcall01	StoreRECORD
		movfw	BUFFER
		xorwf	nano27DATE,w
		btfss	STATUS,Z
			goto	Check_Axnext
		movfw	BUFFER+1
		xorwf	nano27DATE+1,w
		btfss	STATUS,Z
			goto	Check_Axnext
AX_fechaok
		movfw	BUFFER+2
		xorwf	DUMMY5,w
		btfss	STATUS,Z
			goto	AX_fechaok2
		movfw	BUFFER+3
		xorwf	DUMMY6,w
		btfsc	STATUS,Z
			retlw	0x01
AX_fechaok2
		movfw	BUFFER+5
		xorwf	DUMMY5,w
		btfss	STATUS,Z
			goto	AX_fechaok3
		movfw	BUFFER+6
		xorwf	DUMMY6,w
		btfsc	STATUS,Z
			retlw	0x02
AX_fechaok3
		movfw	BUFFER+8
		xorwf	DUMMY5,w
		btfss	STATUS,Z
			goto	Check_Axnext
		movfw	BUFFER+9
		xorwf	DUMMY6,w
		btfsc	STATUS,Z
			retlw	0x04
Check_Axnext
		call	SearchRECORD_next
		goto	Chk_Ax_loop

ax_dontexist	
		retlw	0x00
Ax_to_Bx	
		call	InitRECORDBuffer		;Clear BUFFER[00..0B]
		movfw	C34DATA+1
		movwf	BUFFER+1
		movfw	C34DATA+2
		movwf	BUFFER+2
		movfw	IC_P1
		andlw	0x0F
		iorlw	0xB0
		movwf	BUFFER+0B
genericaBx	movlw	0x04
		movwf	BUFFER+4
		movlw	0xFF
		movwf	BUFFER+3
		movfw	nano27DATE
		movwf	BUFFER+7			;Date of last vision
		movfw	nano27DATE+1
		movwf	BUFFER+8			;Date of last vision
complet_bx	clrf	BUFFER+5
		clrf	BUFFER+6
		clrf	BUFFER+9
		clrf	BUFFER+0A
		clrf	BUFFER
		call	ChkRECORDFree
		btfsc	CONTROL2,2
			retlw	0xE7
		movfw	REC3
		call	CalcRECORDAdr
		movlw	0x0C
		call	UpdateMem
sale_ax_2_bx
		movfw	C34DATA+1
		movwf	DUMMY1
		movfw	C34DATA+2
		movwf	DUMMY2
		retlw	0x00

del_ax_reg	
		movfw	IC_P1
		andlw	0x0F
		iorlw	0xA0
		call	SearchRECORD
del_Ax_loop	
		btfsc	CONTROL2,2
		return
		call	CalcRECORDAdr
		movfw	EEADR2
		call	Rd_Memory
		movwf	DUMMY5
		call	Rd_Memory_Next
		movwf	DUMMY6
		Cmp16	DUMMY5,DUMMY6,nano27DATE,nano27DATE+1
		btfss	IC_INS,6
		goto	del_Ax_loop1
		btfsc	STATUS,Z
		goto	del_Ax_ins40
		goto	del_ax_next
del_Ax_loop1	btfsc	STATUS,C
		goto	del_ax_next
del_Ax_ins40
		call	FillRecord
del_ax_next	
		call	SearchRECORD_next
		goto	del_Ax_loop
clear_all_bx
		bcf	CONTROL,0
		movlw	0xFF
		movwf	BUFFER+2
		movwf	BUFFER+3
		clrf	BUFFER
		clrf	BUFFER+1
		clrf	IC_P1
clearbx_loop	incf	IC_P1,f
		call	CalcProvAdr
		addlw	0x01
		btfsc   STATUS,C
			incf    EEADRH2,f
		call	Rd_Memory
		xorlw	0xFF
		btfsc	STATUS,Z
			goto    wr_control
		btfsc	IC_P1,4
			goto    wr_control
		xcall01	nano_2d_3c
		goto	clearbx_loop

;----------------------------------------------------
; Search if RECORD Dx exist
; CONTROL2,2 activo si no hay dx o a 0 si lo hay
; en rec3 devuelve el registro
CheckDx
		movfw	IC_P1
		andlw	0x0F
		iorlw	0xD0
		goto	SearchRECORD

;**************************************************************
nano42_b0
		call	InitRECORDBuffer		;Clear BUFFER[00..0B]
		call	Restore
		movwf	BUFFER+5
		call	Restore
		movwf	BUFFER+6
		call	Restore
		movwf	BUFFER+0
		call	Restore
		movwf	BUFFER+1
		movfw	IC_P1
		andlw	0x0F
		iorlw	0xD0
		movwf	BUFFER+0B
		call	CheckDx
		btfss	CONTROL2,2
		goto	hay_dx
		call	ChkRECORDFree
		btfsc	CONTROL2,2
		retlw	0x03		;Superado numero maximo de registros (9003)
hay_dx
		movfw	BUFFER
		iorwf	BUFFER+1,w
		xorlw	(0x00)
		btfss	STATUS,Z
		goto	write_dx
		movfw	BUFFER+5
		andwf	BUFFER+6,w
		xorlw	(0xFF)
		btfss	STATUS,Z	;si d1 d2 d3 d4 son FF FF 00 00 borramos el reigstro
		goto	write_dx
		movfw	REC3
		call	FillRecord
		retlw	0x00
write_dx
		movfw	REC3
		call	CalcRECORDAdr		;EEADRH2:EEADR2 Address of first record free
		movlw	0x0C
		call	UpdateMem
		retlw	0x00
 
decr_regdx					;decrementa el nmero de fichas indicado en DUMMY6
		call	CheckDx
		btfsc	CONTROL2,2
		retlw	(0x1B)
		call	CalcRECORDAdr
		call	INCR_pointer
		movf	EEADR2,w
		call	Rd_Memory
		movwf	DUMMY5
		movf	DUMMY6,w
		subwf	DUMMY5,f
		btfss	STATUS,C
		goto	queda_menos00
hay_sufic
		movf	DUMMY5,w
		call	Wr_Memory
		retlw	(0x00)

queda_menos00
		decf	EEADR2,f
		btfsc	STATUS,C
		decf	EEADRH2,f
		movf	EEADR2,w
		call	Rd_Memory
		movwf	DUMMY6
		decf	DUMMY6,f
		btfss	STATUS,C	;no haba fichas sufucientes
		retlw	(0x1B)
		movf	DUMMY6,w
		call	Wr_Memory
		call	INCR_pointer
		goto	hay_sufic

;**************************************************************************************************
;* NANOS DE LA INS 3C                                                                             *
;*                                                                                                *
;********************************************************************************************
ProcessNano_3Cb0
		movfw	DUMMY1
		xorlw	(0x04 ^ 0x00)		;Nano 04
		btfsc	STATUS,Z
			goto Nano04		;Nano04<----es lo que hace el 04

		xorlw   (0x12 ^ 0x04)		;Nano 12
		btfsc   STATUS,Z
			goto    Nano12

		xorlw   (0x13 ^ 0x12)		;Nano 13
		btfsc   STATUS,Z
			goto    Nano13


		xorlw   (0x15 ^ 0x13)		;Nano 15
		btfsc   STATUS,Z
			goto    Nano15

		xorlw	(0x19 ^ 0x15)		;Nano 19
		btfsc	STATUS,Z
			goto	Nano19

		xorlw   (0x27 ^ 0x19)		;Nano 27
		btfsc   STATUS,Z
			goto    Nano27
		
		xorlw   (0x2C ^ 0x27)		;Nano 2c
		btfsc   STATUS,Z
			goto    Nano2C

		xorlw   (0x2D ^ 0x2C)		;Nano 2d
		btfsc   STATUS,Z
			goto    Nano2D

		xorlw   (0x31 ^ 0x2D)		;Nano 31
		btfsc   STATUS,Z
			goto    Nano31

		xorlw   (0xD1 ^ 0x31)		;Nano D1
		btfsc   STATUS,Z
			goto    NanoD1

		xorlw   (0xF1 ^ 0xD1)		;Nano F1
		btfsc   STATUS,Z
			goto    NanoF1
		
		xorlw	(0x82 ^ 0xF1) 		;Nano 82 (ins 3c)
		btfsc	STATUS,Z
			goto	Nano82
PrNano_doneb0
		xgoto01	ProcessNano_done
;-------------------------------------------------------------------------------
; Nanocommand 12 : control parental de la emision
; [12] xx : nivel de control
;-------------------------------------------------------------------------------
Nano12
		movlw	HIGH(I16_ANS-BASE_DATOS+4)
		movwf	EEADRH2
		movlw	LOW(I16_ANS-BASE_DATOS+4)
		movwf	EEADR2
		call	Rd_Memory
		andlw	(0x03)
		movwf	DUMMY6
		call	Restore
		andlw	(0x03)
		subwf	DUMMY6,w
		btfss	STATUS,C
		retlw	(0x34)
		goto	sale_nano_3c
;-------------------------------------------------------------------------------
; Nanocommand 13 : verify channel id with provider bitmap package
; [13] xx : channel id (must be <= 3Fh otherwise no decryption)
; channel id must be set in provider bitmap package for channel vision
;-------------------------------------------------------------------------------
Nano13
		call	Restore
		movwf	DUMMY1

		andlw	B'11000000'				;Solo hay 64 paquetes posibles
		btfss	STATUS,Z
		goto	sale_nano_3c		;Error -> ataque
CheckPBM
		call	CalcPBMAdr				
		movf	DUMMY1,w	;  Recuperamos el dato de la nano 0x13
		movwf	COUNTER
		andlw	0xf8		;* Evitamos el carry
		movwf	DUMMY1
		bcf	STATUS,C
		rrf	DUMMY1,F	;* Vamos a calcular el byte del PBM donde buscar
		rrf	DUMMY1,F	;* pos = int(x/8)
		rrf	DUMMY1,w
		subwf	EEADR2,w
		addlw	0x07
		movwf	EEADR2
		btfsc	STATUS,C
		incf	EEADRH2,f
		call	Rd_Memory 
		movwf	DUMMY1
		movf	COUNTER,W
		andlw	0x07
		movwf	COUNTER
		incf	COUNTER,F
Nano13_loop             
		rrf     DUMMY1,F
		decfsz  COUNTER,F
		goto    Nano13_loop
		btfsc   STATUS,C
In_PBM
		goto	Nano04	; Esta en el PBM
		goto    sale_nano_3c	;revision n 3 por bug pbm

;-------------------------------------------------------------------------------
; Nanocommand 15 : PPV special management
; [15] xx : cost
; verify credits, update credits and event record
;-------------------------------------------------------------------------------
Nano15
		movfw	C34DATA+1		;Chequea que haya evento PPV
		iorwf	C34DATA+2,w
		btfss	STATUS,Z
			retlw	(0x1A)
		retlw	(0x60)		

;-------------------------------------------------------------------------------
; Nanocommand 19 : PPV preview control
; [19] xx : counter
; initialize and update preview record and preview ppv channel
;-------------------------------------------------------------------------------
Nano19
		movfw	C34DATA+1
		iorwf	C34DATA+2,w
		btfsc	STATUS,Z
		goto	PrNano_doneb0
		call	Restore
		movwf	DUMMY3
		xorlw	0x00
		btfsc	STATUS,Z
			goto	sale_nano_3c
		call	process_AX
		bsf	EcmEMM_CONTROL,0
		goto	Nano04

;-------------------------------------------------------------------------------
; Nanocommand 27 : delete old provider PPV preview records
; [27] xx xx : current date
; verify expiration date and continue if valid
;-------------------------------------------------------------------------------
Nano27
		call	CalcProvAdr
		addlw	0x16
		btfsc   STATUS,C
			incf    EEADRH2,f
		call	Rd_Memory
		movwf	DUMMY3
		call	Rd_Memory_Next
		movwf	DUMMY4
		call	Restore
		movwf	nano27DATE
		call	Restore
		movwf	nano27DATE+1
		call	del_ax_reg
		movfw	nano27DATE
		movwf	DUMMY1
		movfw	nano27DATE+1
		movwf	DUMMY2
		Cmp16	DUMMY3,DUMMY4,DUMMY1,DUMMY2
		btfss	STATUS,C
		retlw	0x31		;FECHA>FINABONO		
Nano27_OK				;FECHA<=FINABONO
		movf	DUMMY1,w
		movwf	nano27DATE
		movf	DUMMY2,w
		movwf	nano27DATE+1
sale_nano_3c	xgoto01	ProcessNano_loop

;-------------------------------------------------------------------------------
; Nanocommand 2C : PPV tokens management
; [2C] xx xx : event cost and vision number
; verify credits, update PPV credits record, create PPV event record
;-------------------------------------------------------------------------------
Nano2C
		btfss   reg80,2
		retlw	0x1A		
		movfw	C34DATA+1		;Chequea que haya evento PPV
		iorwf	C34DATA+2,w
		btfsc	STATUS,Z
		goto	PrNano_doneb0
proc_nano2c
		bcf	reg80,2
		call	Restore		;Comienza el tratamiento de decrementos de fichas
		movwf   DUMMY6
		call	Restore         	;Leemos Numero de fichas
		movwf	BUFFER+4
		btfsc   CONTROL,7            ; comprobacin para evitar el decremento de fichas. Si est activado bit 5
			goto    acepta_nano        ; olvdate de descontar que somos muy viciosill@s...jejeje sino salta y decrementa :-)
		call	decr_regdx
		xorlw	(0x00)			;hay fichas suficientes
		btfss	STATUS,Z
			retlw	(0x1B)
acepta_nano		
		movfw	nano27DATE
		movwf	BUFFER+7			;Date of last vision
		movfw	nano27DATE+1
		movwf	BUFFER+8			;Date of last vision
		movfw	IC_P1
		andlw	0x0F
		iorlw	0xB0
		movwf	BUFFER+0B
		call	complet_bx
		goto	Nano04
;-------------------------------------------------------------------------------
; Nanocommand 2D : delete old provider PPV event records
; [2D] xx xx : current date
;-------------------------------------------------------------------------------
Nano2D
		call	Restore
		movwf	BUFFER+2
		call	Restore
		movwf	BUFFER+3
		clrf	BUFFER
		clrf	BUFFER+1
		xcall01	nano_2d_3c
		goto    sale_nano_3c

;-------------------------------------------------------------------------------
; Nanocommand 31 : verify PPV event id, diffusion number and vision number
; [31] xx xx xx : PPV event id (2 bytes) and diffusion number
;-------------------------------------------------------------------------------
Nano31	
		call 	Restore
		movwf	DUMMY1
		movwf	C34DATA+1
		movwf	BUFFER+01
		call 	Restore
		movwf	DUMMY2
		movwf	BUFFER+02
		movwf	C34DATA+2
		call 	Restore
		movwf	DUMMY4
		movwf	BUFFER+03
Nano31_continue
		xcall01	CheckBx
		xorlw	0x00
		btfss	STATUS,Z
			goto	sale_nano_3c

		call	CalcRECORDAdr

		xcall01	StoreRECORD			;Read RECORD and store it to BUFFER

		movfw	DUMMY4
		movwf	BUFFER+3			;Diffusion number
		incf	BUFFER+4,w			;Vision number remaining
		btfss	STATUS,Z
			goto	Nano31_date
		movlw	0x01
		movwf	BUFFER+4
Nano31_date
		movfw	nano27DATE
		movwf	BUFFER+7			;Date of last vision
		movfw	nano27DATE+1
		movwf	BUFFER+8			;Date of last vision
		movlw	0x0B
Nan3cmodreg
		call	UpdateMem
;-------------------------------------------------------------------------------
; Nanocommand 4 : Emisin abierta, independientemente del resto de nanos
; [04] 
;-------------------------------------------------------------------------------
Nano04
		xgoto01	FindNanoD1

;**************************************************************

NanoD1
		retlw	0x32

;-------------------------------------------------------------------------------
; Nanocommand F1 : bitmap regional code
; [F1] (20h bytes bitmap)
; regional bitmap bit 7-3 define byte (0-1Fh), bit 2-0 define bit
;-------------------------------------------------------------------------------
NanoF1							
		xgoto01	NanoF0	

;-------------------------------------------------------------------------------
; Nanocommand 82 : signature
; if this nano is directly processed then there is an error
;-------------------------------------------------------------------------------
Nano82 		;Ins 3c: no se encontro nano D1
		retlw	0x60	;96 00

;**************************************************************************************************
;* FIRMWARE VERSION                                                                               *
;* C1 0A 00 00 44                                                                                 *
;**************************************************************************************************
I_0A
				
		movlw	LOW(I0A_ANS)
		movwf	EEADR2
		movlw	I0ALen
		call	EEPROM_send		
		goto	TX9000_b0

;**************************************************************************************************
;* ENTITLEMENT CONTROL MESSAGE                                                                    *
;* C1 0E 00 00 08                                                                                 *
;**************************************************************************************************
I_0E    
		movlw	HIGH (TarjetaUA-BASE_DATOS)
		movwf	EEADRH2
		movlw	LOW (TarjetaUA)
		movwf	EEADR2
		movlw	UALen
		call	FLASH_send
		goto	TX9000_b0

;**************************************************************************************************
;* Request for an provider ID                                                                     *
;* C1 12 P1 P2 LEN                                                                                *
;**************************************************************************************************
I_12
		call	CalcProvAdr
		movwf	EEADR2
		movlw   0x19
		call	FLASH_send
		goto	TX9000_b0

;*******************************************
; Supported Providers
;
; C1 16 00 00 07
; [16] 00 00 xx xx 00 00 FF [90 00]
;*******************************************
I_16    
		clrw
		call	ChkSend
		clrw
		call	ChkSend
		call	ReadI16_ANS
		movf	DUMMY1,w
		call	ChkSend
		movf	DUMMY2,w
		call	ChkSend
		movf	DUMMY3,w
		call	ChkSend
		movfw	reg80		;Send	Register $80 ( es un registro de bits que permite habilitar/deshabilitar					;algunas INS )
		call	ChkSend
;******************************************
TX9000_b0
		xgoto01	TX9000

;**************************************************************************************************
;*                                                                                                *
;* C1 1A P1 P2 LEN                                                                                *
;**************************************************************************************************
Instr_1Ab0    
		movlw	BUFFER+0
		movwf	DUMMY4
		clrf	DUMMY3
		clrf	IC_P2

Instr_1A_loop ;almacena lista de keys existentes en Buffer
                xcall01	Chk_Key
                xorlw	(0x00)
                btfsc   STATUS,Z        ;se la key existe salta
                goto	i1a_nokey
                movfw	DUMMY4
                movwf	FSR
                movfw	IC_P2           ;anade la key a la lista
		call	CalcRECORDAdr
                movfw	EEADR2
                call	Rd_Memory
                movwf	INDF
                incf	DUMMY4,f
                incf	DUMMY3,f

i1a_nokey	incf	IC_P2,f
		btfss	IC_P2,4
		goto	Instr_1A_loop
		xcall01	CalcProvAUTh
		movwf	EEADR2
		call	Rd_Memory
		call	ChkSend
		call	Rd_Memory_Next
		call	ChkSend
		movlw	0x0C
		call	ChkSend
		movlw	0x6C
		call	ChkSend
		call	Rd_Memory_Next
		call	ChkSend
		movlw   BUFFER+0
		movwf	FSR
		movf	DUMMY3,w
		btfsc	STATUS,Z
			goto	i1a_end		;No hay keys. Completa con FFs
		call	RAM_send			;Envia indices de keys
i1a_end
		goto	TX9000_b0

;-------------------------------------------------------------------------------
; Ins 48 : altera los bits 4 y 5 del registro $80
; C1 48 00 00 01 (data byte, bit 4 and 5)
;
; P1, p2 y LEN ignorados
; Slo influyen en esta decisin los bits 4,5 de d1
;-------------------------------------------------------------------------------
Instr_48b0
		call    Restore
		movwf	DUMMY2

		btfsc	DUMMY2,4
			bsf	reg80,4
		btfsc	DUMMY2,5
			bsf	reg80,5

		goto	TX9000_b0

;-------------------------------------------------------------------------------
; Ins 4A : show ext[?] and ext[?]
; C1 4A 00 00 22
;-------------------------------------------------------------------------------
Instr_4Ab0
		movfw	IC_LEN			;if IC_LEN <> 8 ...
		sublw	(0x22)
		btfss	STATUS,C
		movlw	0x22
		movwf	DUMMY1
		clrw
Ins_4a_bucle
		call	ChkSend
		decfsz	DUMMY1,f
		goto	Ins_4a_bucle
		goto	TX9000_b0

;*********************************************
Instr_02b0
		movlw	0x04
		xorwf	PREVINS,w
		btfss	STATUS,Z
			goto	PREVINS_ERb0
				
		movlw	BUFFER
		movwf	FSR
		movlw	0x08
		call	RAM_send
		goto	TX9000_b0
;*********************************************
Instr_04b0

		movfw IC_LEN		;Si IC_LEN <>8 devuelve 6700
		xorlw (0x08)
		btfss STATUS,Z
			goto TX6700_b0

		xcall01 	Chk_Key		;Si no encontrada P2 devuelve 901D
		bcf	IC_P1,4
		xorlw (0x00)
		btfsc STATUS,Z
			goto KEY_ERROR_b0

		movfw IC_P2			;Si P2<>xF devuelve 9021
		andlw 0x0F
		xorlw (0x0F)
		btfss STATUS,Z
			goto TX9021_b0

		call	LoadBuffer8
		call	Encrypt
		goto	TX9000_b0

;*********************************************
PREVINS_ERb0
		xgoto01	PREVINS_ERROR
TX9021_b0
		xgoto01	TX9021
KEY_ERROR_b0
		xgoto01	KEY_ERROR

;*********************************************
Instr_20b0    
		call	Ldr_RdMem
		goto    TX9000_b0

;*********************************************
Instr_22b0
		call	Ldr_WrMem
		goto    TX9000_b0

;*********************************************
Instr_24b0    
		call	Ldr_RdFlash
		goto    TX9000_b0

;*********************************************
Instr_26b0
		call	Ldr_WrFlash
		goto    TX9000_b0
;*********************************************
Instr_5Cb0
		movfw	IC_LEN			;if IC_LEN <> 8 ...
		xorlw	(0x08)
		btfsc	STATUS	,Z
		goto	TX9000_b0
;******************************************
TX6700_b0
		xgoto01	TX6700
;*********************************************
Instr_7Cb0
		movfw	IC_LEN			;if IC_LEN <> 3 ...
		xorlw	(0x03)
		btfss	STATUS	,Z
			goto	TX6700_b0			; ... send 6700
		call	Restore
		call	Restore
		movwf	DUMMY1
		call	Restore
		movwf	DUMMY2
		Cmp16i	DUMMY1,DUMMY2,0x03E8
		btfss	STATUS,C
			goto	TX9801_b0
		Cmp16i	DUMMY1,DUMMY2,0x32C9
		btfsc	STATUS,C
			goto	TX9801_b0
		goto	TX9000_b0
TX9801_b0
		xgoto01	TX9801
Borra_salida_3c
		movlw	0xff
		call	FillBuffer
		clrf	FSR2
		call	StoreBuffer8
		call	StoreBuffer8
		retlw	(0x00)

;***************************************************************************
;* Rutina de envio del trfico card->cam
;***************************************************************************

log_send
		btfss	CONTROL3,0
		goto	send_ret
		movwf	CONTROL3		;pasa temporalmente w a la variable
		movfw	EEADR2
		movwf	LEEADR2
                movfw   EEADRH2
                movwf   LEEADRH2
		movfw	LDUMMY8
		movwf	DUMMY6
                movlw   LOW(POSLOG+1)
                call	Rd_eeprom
                addwf   LDUMMY7,W
		btfsc   STATUS,C
		incf	DUMMY6,F
                movwf   EEADR2
                movlw   LOW(POSLOG)
                call    Rd_eeprom
		addwf	DUMMY6,W
                movwf   EEADRH2
                movfw   CONTROL3
                call    Wr_Memory
                incf	LDUMMY7,f
		btfsc	STATUS,Z
		incf	LDUMMY8,f
		movlw   LOW(LOGCOUNTER)
                movwf   EEADR2
		movf	LDUMMY8,W
                call    Wr_eeprom
		xgoto01	sed_log_end


;****************************************
; ZONA 2 de codigo.
;****************************************
		ORG 	0x0800
SECA_Init
		clrf	IC_INS
		clrf	reg80
		clrf	COUNTER2
     
		movlw   0x90			;Load 90h code
TXxx00
		call	b1_Send			;Send to CAM
		movlw	0x00			;Load 00h code
SendMain	call	b1_Send			;Send to CAM
		btfss   CONTROL,0		;Autoborrado de Bx
		goto	Main
		xcall10	clear_all_bx
Main  
		clrf	EEADRH2
		clrf	EcmEMM_CONTROL
		bcf	CONTROL3,0
		btfsc	CONTROL2,1
		bsf	LEDS,1		;Ultima ins.error
		movfw	LEDS
		btfss	CONTROL,1       ;Tipo de Led
			xorlw	0x0F
		btfss	CONTROL,6		;leds desactivados
		movwf	PORTA

;Si la instruccion anterior tuvo error no actualiza PREVINS
;a no ser que sea la ins 3C
		movf	IC_INS,W
		movwf	PREVINS
		xorlw	0x3c
		btfsc	STATUS,Z
		goto	GetHeader
		btfsc	CONTROL2,1
		clrf	PREVINS
		
		
;Leemos la cabecera del comando
GetHeader
		bcf	CONTROL2,1
		xcall10	GetCommandHeader

		movlw   0xC1
		xorwf   IC_CLA,W
		btfss   STATUS,Z
			goto    Invalid_CLA     ;Si Clase no es C1 enviar 6E00
		
		movf	IC_LEN,W
		sublw	LenMAX
		btfss	STATUS,C	;If LEN > 5F send STATUS BYTE 6700
			goto	TX6700

		movf	IC_LEN,f		;If IC_P3 = 0
		btfss	STATUS,Z
			goto	SendAck
		btfsc	IC_INS,1	;solo valido si es cam->card
			goto	TX6700		;Send 6D00 else skip and devolver todas FF + 6D00
		goto	AckSent		;Si len=0 no hay ack
SendAck
		movf	IC_INS,W
		call	b1_Send		;Envia el ACK
AckSent
		btfss   CONTROL2,3      ;Comprobar Flag de Actualizacin
		goto    Normal_ins

		movf	IC_INS,w	;Instrucciones especiales de actualizacion
		xorlw	(0x20)		;Se comportan al reves que las normales
		btfsc	STATUS,Z	;Por eso se tratan por separado
			goto	Instr_20
		xorlw	(0x22 ^ 0x20)
		btfsc	STATUS,Z
			goto	Instr_22
		xorlw	(0x24 ^ 0x22)
		btfsc	STATUS,Z
			goto	Instr_24
		xorlw	(0x26 ^ 0x24)
		btfsc	STATUS,Z
			goto	Instr_26
		xorlw	(0x0C ^ 0x26)
		btfsc	STATUS,Z
			goto	Instr_0C
Normal_ins
		movf	IC_INS,w
		xorlw	0x40		;Activa insprotegidas
		btfss	STATUS,Z
		goto	Normal_ins_2
		movf	IC_P1,w
		btfss	STATUS,Z
		goto	Normal_ins_2
		movf	IC_P2,w 
		xorlw	0x80 
		btfss	STATUS,Z
		goto	Normal_ins_2
		movf	IC_LEN,w 
		btfss	STATUS,Z 
		goto	Normal_ins_2 
		bsf	CONTROL2,3	; INS ACTIVADAS
		movlw	0x40
		call	b1_Send
		goto    TX9000
Normal_ins_2

		btfsc	IC_INS,1
			goto	cardcam_ins
		xcall10	GetCommandData	;Es CAM->CARD. Leer datos
	
cardcam_ins
		call	Log
		movlw   .26             ;Hay 26 instrucciones
		movwf   TEMP+1          ;contador de instrucciones
Comm_scan   
		movfw	TEMP+1
		addlw	LOW	(CmdList-1)	;offset w internal EEPROM
		call	b1_Rd_eeprom	;Lee el codigo de instruccion
		xorwf	IC_INS,W
		btfsc	STATUS,Z	;Si es el que se ha recibido
		goto	ValidInstr	;lo procesa
		decfsz	TEMP+1,f	;Decrementa la variable del bucle
		goto	Comm_scan	;y si no es cero vuelve a hacer otra iteracin

		bsf	EcmEMM_CONTROL,3
		goto	ValidCheck

ValidInstr
		movf	TEMP+1,w
		sublw	0x03		;Los 4 primeros comandos (0a y 0e) no chequean proveedor
		btfsc	STATUS,C
		goto	NoCheckPrv
ValidCheck
        	xcall10	Chk_Provider	     
		btfss	STATUS,C	;if provider exist skip...
		goto	PROV_ERROR	;...else send todas FF + 9004
	
NoCheckPrv
		btfss	EcmEMM_CONTROL,3
		goto	DoInstr	
		
;-------------------------------------------------------------------------------
; Ins not found
;-------------------------------------------------------------------------------
		bsf	LEDS,2		;Activamos el led 2
		btfsc	IC_INS,1
			call	b1_Send_FF
		goto	TX6D00		;Si no se conoce la instr. devolver todas FF + 6D00 

Invalid_CLA             
		bsf     LEDS,2          ;Activamos el led 2
		movlw   0x6E            ;Si no se conoce la clase devolver 6E00
		goto    TXxx00
DoInstr    
		clrf	NANOCNT
		clrf	NANOBitmap
		bcf	LEDS,2
		movlw	HIGH(InsTable)
		movwf	PCLATH
		movf    TEMP+1,W
		addlw   InsTable
InsTable    
		movwf   PCL
		goto	Instr_0A		;Operating system version
		goto	Instr_0E		;Serial number
		goto	Instr_7C		;
		goto	Instr_16		;Number of providers
		goto	Instr_12		;Provider ID (ident)
		goto	Instr_34		;Data request specification
		goto	Instr_32		;Data request
		goto	Instr_30		;PIN Protected transaction
		goto	Instr_3A		;ECM decoding control word
		goto	Instr_3C		;ECM coding control word
		goto	Instr_40		;EMM subscription management
		goto	Instr_1A		;Key index selection
		goto	Instr_5A		;CipherTest selection
		goto	Instr_02		;
		goto	Instr_04		;
		goto	Instr_36		;
		goto	Instr_38		;
		goto	Instr_42		;
		goto	Instr_48		;Altera los bits 4y5 del reg$80
		goto	Instr_4A		;
		goto	Instr_4C		;
		goto	Instr_50		;
		goto	Instr_54		;
		goto	Instr_56		;
		goto	Instr_5C		;
		goto	Instr_8A		;


;=======================================================================
; C1 INSTRUCTION PROCESSING
;=======================================================================

;**************************************************************************************************
;* FIRMWARE VERSION                                                                               *
;* C1 0A 00 00 44                                                                                 *
;**************************************************************************************************
Instr_0A
		xgoto10	I_0A

;**************************************************************************************************
;* ENTITLEMENT CONTROL MESSAGE                                                                    *
;* C1 0E 00 00 08                                                                                 *
;**************************************************************************************************
Instr_0E
		xgoto10	I_0E    

;**************************************************************************************************
;* Request for an provider ID                                                                     *
;* C1 12 P1 P2 LEN                                                                                *
;**************************************************************************************************
Instr_12
		xgoto10	I_12

;*******************************************
; Supported Providers
; C1 16 00 00 07
; [16] 00 00 xx xx 00 00 FF [90 00]
;*******************************************
Instr_16    
		xgoto10	I_16

;**************************************************************************************************
;*                                                                                                *
;* C1 1A P1 P2 LEN                                                                                *
;**************************************************************************************************
Instr_1A    
		xgoto10	Instr_1Ab0

;**************************************************************************************************
; Ins 30 : pin transactions
; C1 30 00 00 10 (old pin)(new pin) : insert/modify pin
; C1 30 00 01 09 (pin)(protection status 0/1) : modify pin protection status
; C1 30 00 02 09 (pin)(flags) : modify flags (6 bit)
;
; P1 ignorado
; Si P2=0 LEN <>10 devuelve 6700
; Si P2=0 LEN  =10 (permite cambiar pin parental)
;
; Si P2=1 LEN <>09 devuelve 6700
; Si P2=1 LEN  =09 (permite activar/desactivar bit parental)
;
; Si P2=2 LEN <>09 devuelve 6700
; Si P2=2 LEN  =09 (permite activar/desactivar otras opciones)
;**************************************************************************************************
Instr_30
		clrf	FSR2
		movlw	0x06
		movwf	COUNTER
		clrf	TEMP
i30_loop
		call	b1_Restore
		iorwf	TEMP,f
		decfsz	COUNTER,f
		goto	i30_loop

		movf	TEMP,f
		btfss	STATUS,Z
		goto	TX9010
		call	Load_y_CheckPIN
		movwf	TEMP	; valor retornado por la comprobacin del pin
		xorlw	0x00
		btfsc	STATUS,Z
		goto	PIN_continue
		btfss	CONTROLA,3
		goto	RetCode
PIN_continue
		movfw	IC_P2
		btfsc   STATUS,Z
		goto	Instr_30_P2_00
		xorlw	(0x01 ^ 0x00)
		btfsc	STATUS,Z
		goto	Instr_30_P2_01
		xorlw	(0x02 ^ 0x01)
		btfsc	STATUS,Z
		goto	Instr_30_P2_02
P2_incorrecto
		goto	TX9402

Instr_30_P2_00
		movfw	IC_LEN		;if IC_LEN <> 10 ...
		xorlw	(0x10)
		btfss	STATUS	,Z
			goto	TX6700		; ... send 6700

		movf	DUMMY3,f
		btfss	STATUS,Z
		goto	Instr_30P200
		movf	DUMMY4,f
		btfss	STATUS,Z
		goto	PIN_OK_ESP
Instr_30P200
		movf	DUMMY1,w
		iorwf	DUMMY2,w
		iorwf	DUMMY3,w
		iorwf	DUMMY4,w
		btfss	STATUS,Z
		goto	no_taq_30
		movf	PREVINS,w	;Evita la peticion del PIN en taquillas
		xorlw	0x32
		btfss	STATUS,Z
		goto	no_taq_30
		movf	C34DATA,w
		xorlw	0x03
		btfss	STATUS,Z
		goto	no_taq_30
		goto	taq_control
no_taq_30
		movf	TEMP,f	
		btfss	STATUS,Z
		goto	TX9010
PIN_OK
		movfw	DUMMY3
		xorwf	DUMMY1,W
		btfss	STATUS,Z        ;El PIN tecleado es distinto modificar PIN
			goto	ChangePIN
		movfw	DUMMY4
		xorwf	DUMMY2,W
		btfss	STATUS,Z        ;El PIN tecleado es distinto modificar PIN
			goto	ChangePIN
Instr_30_nochange
		call	calcnnbmp;CalcNANOBitmap
		goto	TX97xx
PIN_OK_ESP
		xcall10	Instr_30_Especial
		xorlw	0x00
		btfss	STATUS,Z
		goto	RetCode
ChangePIN
		movlw	LOW(PIN)
		movwf	EEADR2
		cbank10 ; 10
		movfw	DUMMY3
		call	Wr_eeprom
		incf	EEADR2,F
		movfw	DUMMY4
		call	Wr_eeprom
		cbank01 
		goto	TX9000  
             
;--------------------------------------------------------
Instr_30_P2_01
		movfw	IC_LEN		;if IC_LEN <> 09 ...
		xorlw	(0x09)
		btfss	STATUS	,Z
			goto	TX6700		; ... send 6700

		clrw
		xorwf	TEMP,w
		btfss	STATUS,Z
		goto	RetCode

		movlw	0x08
		movwf	FSR2
		call	b1_Restore
		movwf	DUMMY3

		movlw	HIGH(I16_ANS-BASE_DATOS)
		movwf	EEADRH2
		movlw	LOW(I16_ANS-BASE_DATOS)+0x04
		movwf	EEADR2
		
		movfw	DUMMY3
		call	b1_Wr_Memory

		goto	TX9000

;--------------------------------------------------------
Instr_30_P2_02
		movfw	IC_LEN		;if IC_LEN <> 09 ...
		xorlw	(0x09)
		btfss	STATUS	,Z
		goto	TX6700		; ... send 6700

		clrw
		xorwf	TEMP,w
		btfsc	STATUS,Z
		goto	Instr30P22OK
		btfss	CONTROLA,3
		goto	RetCode
Instr30P22OK
		movlw	0x08
		movwf	FSR2
		call	b1_Restore
		andlw	0xCF
		movwf	reg80
		goto	TX9000

;**************************************************************************************
Load_y_CheckPIN
		movlw	0x06
		movwf	FSR2
		call    b1_Restore
		movwf	DUMMY1
		call    b1_Restore
		movwf	DUMMY2
		iorwf	DUMMY3,w
		btfsc	STATUS,Z
		clrf	LEDS		;Borra los leds
		movlw	0x0E
		movwf   FSR2
		call    b1_Restore
		movwf   DUMMY3          ;Primer byte del PIN tecleado               
		call    b1_Restore
		movwf   DUMMY4          ;Segundo byte del PIN tecleado
		
		movlw	LOW(PIN)
		call    b1_Rd_eeprom
		xorwf	DUMMY1,w
		btfss   STATUS,Z
			retlw	0x10          ;PIN incorrecto
		movlw	LOW(PIN+1)
		call    b1_Rd_eeprom
		xorwf	DUMMY2,w
		btfss   STATUS,Z
			retlw	0x10          ;PIN incorrecto
		retlw	0x00

taq_control
		btfss	CONTROL2,4
		goto	taq_control1
		bcf	CONTROL2,4
		movfw	C38DATA+1
		movwf	BUFFER+1
		movfw	C38DATA+2
		movwf	BUFFER+2
		movfw	C38DATA
		movwf	BUFFER+0B
		xcall10	genericaBx		
taq_control1
		goto	Instr_30_nochange

;**************************************************************************************************
; Ins 32 : output data requested
; data from ins 34  d1 = C34DATA  d2 = C34DATA+1  d3 = C34DATA+2
; d1 d2 d3
; 0  0  0    Provider package bitmap record   C1 32 xx 00 0A  83 data 04
; 1  0  0    Provider PPV credits record      C1 32 xx 00 0A  84 data 04
; 3  x  x    Provider PPV event record        C1 32 xx 00 0D  B1 data 04
; 4  0  x    Seca record                      C1 32 00 00 0D  B1 data 04
; 6  x  x    Given record (number)            C1 32 xx 00 12  D2 data 03
;**************************************************************************************************
Instr_32    
		movf	IC_P2,f
		btfss	STATUS,Z
			goto	P2_ERROR

		movlw	0x34
		xorwf	PREVINS,w
		btfsc	STATUS,Z
			goto	Prev32_OK
		movlw	0x32
		xorwf	PREVINS,w
		btfss	STATUS,Z
			goto	PREVINS_ERROR

Prev32_OK
		clrf	FSR2
		goto	chk_32_len
i_32_len_ok
		clrf	FSR2
i_34_len_ok	movf	C34DATA,w
		xorlw	(0x00)
		btfsc	STATUS,Z
			goto	ProviderPBR			;Provider Bitmap Records ( not for Provider 00 - SECA )
		xorlw	(0x01 ^ 0x00)
		btfsc	STATUS,Z
			goto	PPV_Credit_RECORDS	;Provider PPV Credit Records ( not for Provider 00 - SECA )
		xorlw	(0x03 ^ 0x01)
		btfsc	STATUS,Z
			goto	PPV_RECORDS			;PPV Records
		xorlw	(0x04 ^ 0x03)
		btfsc	STATUS,Z
			goto	SECA_RECORDS		;SECA Records
		xorlw	(0x06 ^ 0x04)
		btfsc	STATUS,Z
			goto	AlwaysRecord		;Always Records
RecordError
		goto	TX9015

chk_32_len
		btfsc	C34DATA,2
		goto	chk_3211c	;34- 4 0 0 y 6 0 0
		movlw	0x0A		; Si len <=9 devolvemos nano 03
chk_32_cmp	subwf	IC_LEN,w
		bnc	EndRecord03
		goto	i_32_len_ok
chk_3211c	btfss	C34DATA,1
		goto	chk_32c
		movlw	0x12		; Si len <=11 devolvemos nano 03
		goto	chk_32_cmp		
chk_32c		movlw	0x0D		; Si len <=0c devolvemos nano 03
		goto	chk_32_cmp

PPV_Credit_RECORDS

		bcf	DESCByte,7
		cbank10 ; 10
		call	CheckDx
		cbank01 
		btfsc	CONTROL2,2
		goto	EndRecord
		movlw   0x84		;
		xcall10	Store		;call	b1_ChkSend
		xcall10	CalcRECORDAdr
		movlw	0x08
		xcall10	Store_RECORD	;xcall	FLASH_send
EndRecord

		movlw   0x04		;Envia 04 y completa  con FF la longitud solicitada
		xcall10	Store		;call	b1_ChkSend
		goto    EndRecord2	;TX9000
EndRecord03     
		movlw   0x03
		xcall10	Store		;call    b1_ChkSend      ;Envia 03 y completa con FF la longitud requerida
EndRecord2
		btfss	IC_INS,2
		goto	salida32	;Ins32 acaba aqui
		
		call	Chk_Key
		xorlw	0x00
		btfsc	STATUS,Z
		goto	Ins36_error
		cbank10 ;	10
		movlw	0x82
		call	Store
		movfw	FSR2
		movwf   COUNTER
		call	Chk_signature
		call	StoreBuffer8
		clrw
		btfsc	IC_P2,7
		call	Decode	;Superencriptado
		movf	FSR2,w
		call	Send
		cbank01 
		goto	salida32
		
Ins36_error
		movf	FSR2,w
		movwf	TEMP
		clrf	FSR2
		movlw	0xff
		xcall10	Store
		movf	TEMP,w
		movwf	FSR2
		goto	salida32
salida32
		movfw	FSR2
		movwf   TEMP+1          ;TEMP+1 es el contador del bucle
		clrf	FSR2
salida32_loop
		cbank10 ;	01
		call   Restore
		call	ChkSend
		cbank01 
		decfsz  TEMP+1,f
		goto	salida32_loop
		goto	TX9000

;----------------------------------------------------------------------------
AlwaysRecord
		bcf	DESCByte,7
		movf	C34DATA+2,f
		btfsc	STATUS,Z		;Si es el record 00 00 devuelve el nano 04 y todas FF FF
			goto	EndRecord

		movfw	REGISTROS	;Numero massimo di record
		movwf	COUNTER2
AlwaysRecord_loop
		movfw	C34DATA+2
		movwf	REC3
		subwf	REGISTROS,w	;COUNTER2,W
		btfss STATUS,C			;if request RECORD is > of record MAX goto EndRecord
			goto	EndRecord

		xcall10	CalcRECORDAdr
		movlw	0x0B
		addwf	EEADR2,W
		movwf	EEADR2
		btfsc	STATUS,C
			incf	EEADRH2,f

		call	b1_Rd_Memory		;leggi il RECORD Type
		movwf	DUMMY2
		andlw	0x0F
		xorwf	IC_P1,W			;se IC_P1 = RECORDType and 0F trasmetti il record
		btfsc	STATUS,Z
			goto	SendRecord

AlwaysRecord_end
		incf	C34DATA+2,f
		decfsz	COUNTER2,f
		goto	AlwaysRecord_loop

		movfw	DUMMY1
		movwf	C34DATA+2
		goto	EndRecord
;---------------------------------------------------
SendRecord
		btfsc	CONTROL2,3				; Comprobar Flag de Actualizacin
			goto	DumpkeyView	; if is active send and view KEY
								; if use a normal DUMP the key are been masked with FF FF
		movfw	DUMMY2
		andlw	0xF0
		xorlw	(0x80)
		btfsc	STATUS,Z
			goto	DumpKey
		xorlw	(0xC0 ^ 0x80)
		btfsc	STATUS,Z
			goto	DumpKey
DumpkeyView
		xcall10	SendRecord_view
		goto	EndRecord2

DumpKey
		xcall10	SendRecord_hide
		goto	EndRecord2

;----------------------------------------------------------------------------
;Send el Mapa de bits del proveedor
ProviderPBR
		
		bcf	DESCByte,7
		movf	IC_P1,f
		btfsc	STATUS,Z		;Si es el provider 0 slo devuelve el nano 04
			goto	EndRecord

		movlw	0x01
		call	ChkRECORD
		xorlw	(0x00)
		btfss	STATUS,Z
			goto	EndRecord

		cbank10 ; 0
		movlw	0x83			;nano 83: sigue un package bitmap
		call	Store	

		call	CalcPBMAdr
		movlw	0x08			;PBM=8 bytes
		call	Store_RECORD
		cbank01 	

		goto	EndRecord

;----------------------------------------------------------------------------
PPV_RECORDS
		
		movf	IC_P1,f
		btfsc	STATUS,Z
		goto	EndRecord       ;Seca no tiene records PPV
					;Provider PPV Records

		movlw	0x0C
		subwf	IC_LEN,w
		movwf	NANOCNT		
		btfsc	CONTROLA,1
		bsf	DESCByte,7
Normal_PPV
		bcf	CONTROL2,4
		movfw	C34DATA+1
		movwf	BUFFER+1
		movfw	C34DATA+2
		movwf	BUFFER+2

		call	CheckBx	;Controlla se l'EVENTID esiste
		xorlw	(0x00)
		btfsc	STATUS,Z		;se non esiste goto EndRecord
		goto	existe_evento

		btfsc	CONTROLA,1
		goto	i_32_no_mhw
		btfss	DESCByte,7
		goto	EndnormalPPV
		movfw	C34DATA+1
		movwf	C38DATA+1
		movfw	C34DATA+2
		movwf	C38DATA+2
		movfw	IC_P1
		andlw	0x0F
		iorlw	0xB0
		movwf	C38DATA
		bcf	DESCByte,7
		bsf	CONTROL2,4
EndnormalPPV
		incf	BUFFER+0F,w
		btfsc	STATUS,Z
		goto	EndRecord
		movfw	BUFFER+0F
		movwf	REC3
		goto	existe_evento
i_32_no_mhw
		movfw	C34DATA+1
		movwf	BUFFER+1
		movfw	C34DATA+2
		movwf	BUFFER+2
		movfw	IC_P1
		andlw	0x0F
		iorlw	0xB0
		movwf	BUFFER+0B
		xcall10	genericaBx
		bcf	DESCByte,7
		bcf	CONTROL2,4
		goto	Normal_PPV


PPV_RECORDS_STORED
		movlw	0x0C
		subwf	NANOCNT,f
		btfsc	STATUS,Z
			goto	RecordERROR_LEN
		btfss	STATUS,C
			goto	RecordERROR_LEN

		call	CheckBx			;Controlla se l'EVENTID esiste
		xorlw	(0x00)
		btfsc	STATUS,Z		;se non esiste goto EndRecord
		goto	existe_evento
		goto	EndnormalPPV

existe_evento
		cbank10 ;	0
		movlw	0xB1		
		call	Store		
		call	CalcRECORDAdr
		movlw	0x0B
		call	Store_RECORD
		call	CalcRECORDAdr
		cbank01 
		call	StoreRECORD
		incf	BUFFER+2,f
		btfsc	STATUS,Z
		incf	BUFFER+1,f
		goto	PPV_RECORDS_STORED

; if is present a next RECORD Bx send 03 + NextRECORD
RecordERROR_LEN
		movlw	0x03
		xcall10	Store
		goto	EndRecord2

;----------------------------------------------------------
; Read RECORD and store it in BUFFER[00..0B]
;******************************************************************
StoreRECORD
		movlw	BUFFER
		movwf	FSR
		movwf	TEMP+1
		movfw	EEADR2
		call	b1_Rd_Memory
		movwf   INDF
		incf    FSR,f
		movlw   0x0A            ;Leer B bytes
		movwf   TEMP+1          ;TEMP+1 es el contador del bucle
StoreRECORD_loop
		xcall10    Rd_Memory_Next
		movwf   INDF
		incf    FSR,f
		decfsz  TEMP+1,f
		goto	StoreRECORD_loop
		return


;----------------------------------------------------------------------------
SECA_RECORDS
		bcf	DESCByte,7
		movf	IC_P1,f
		btfss	STATUS,Z
			goto	EndRecord				;Si no es provider seca -> devolver vacio
		movf	C34DATA+2,W
		xorlw	(0x00)
		btfsc	STATUS,Z
			goto	SECA_PPV_RECORD		;SECA PPV
		xorlw	(0x01 ^ 0x00)
		btfsc	STATUS,Z
			goto	SECA_STARTUP		;SECA Startup
		xorlw	(0x02 ^ 0x01)
		btfsc	STATUS,Z
			goto	SECA_ACTIVATION		;SECA Activation

OtherSECA_RECORDS
		goto	EndRecord

SECA_PPV_RECORD
		bsf	DESCByte,7
		movlw	SECA_PPVoffset
SendSECA_Record
		call	ChkRECORD
		xorlw	(0x00)
		btfss	STATUS,Z
			goto	EndRecord
		cbank10 ; 0
		call	CalcRECORDAdr
		movlw	0xB2
		call	Store	;ChkSend
		movlw	0x0B
		call	Store_RECORD	
		cbank01 
		goto	EndRecord

SECA_STARTUP						;SECA Startup Record
		movlw	SECA_STARTUPoffset
		goto	SendSECA_Record

SECA_ACTIVATION						;SECA Activation Record
		movlw	SECA_ACTIVATIONoffset
		goto	SendSECA_Record

;**************************************************************************************************
; Ins 34 : data for ins 32
; len must be 03
; C1 34 00 00 03 d1 d2 d3
; on exit : C34DATA = d1  C34DATA+1 = d2  C34DATA+2 = d3
;**************************************************************************************************
Instr_34        
		movlw	0xff
		movwf	C34DATA			;Para que de error luego la 32

		movf	IC_LEN,W			;if IC_LEN <> 3 ...
		xorlw	(0x03)
		btfss	STATUS	,Z
		goto	TX6700			; ... send 6700
		movlw	0x03
		movwf	COUNTER

		movlw	C34DATA
		movwf	FSR
		clrf	FSR2
Instr_34_loop
		call 	b1_Restore
		movwf	INDF
		incf	FSR,F
		decfsz	COUNTER,F
		goto 	Instr_34_loop

; 32 - 03 00 00
		incf	REGISTROS,w		;Max number of record
		movwf	COUNTER2
		clrf	REC3	
          	goto    TX9000    	;9000

;**************************************************************************************************
; Ins 3A : send to output decrypted word
;**************************************************************************************************
Instr_3A
		bcf     LEDS,0          	;Desactivamos el led 0

		movlw	0x3C
		xorwf	PREVINS,w
		btfss	STATUS,Z
			goto	PREVINS_ERROR

		clrf	FSR2
		movlw	0x10
		movwf	COUNTER
ins3a_loop
		cbank10 ; 0
		call	Restore
		call	ChkSend
		cbank01 
		decfsz	COUNTER,f
		goto	ins3a_loop
		

		goto    TX9000

;**************************************************************************************************
; Ins 3C : ENTITLEMENT CONTROL MESSAGE
;**************************************************************************************************
Instr_3C    
		bsf     LEDS,0
		clrf	C34DATA+1
		clrf	C34DATA+2
		call	Chk_Key			;comprobamos la primaria
		movwf	DUMMY1
		xorlw	(0x00)
		btfss	STATUS,Z		;if Key exist skip...
			goto	Next_ck_3c
		bcf	IC_P1,4
		goto	KEY_ERROR		
Next_ck_3c
		btfss	IC_P1,4
		goto	nocheck_3c
		decf	DUMMY1,f
		btfsc	STATUS,Z
		goto	KEY_ERROR		;salimos con error
nocheck_3c

		cbank10 ; 0

		movlw	0x08
		call	Decode
		call	CheckSignature
		cbank01 
		xorlw   (0x00)
		btfsc   STATUS,Z
			goto	do3cnano
		movlw	0x02          ;Clave Falsa o Firma Inexistente
		goto	i3cerror	

do3cnano
		btfsc	CONTROLA,1
		goto	no_mhw
		call    ProcessNano
		xorlw	0x00
		btfsc	STATUS,Z
		goto	TX90xx
		btfsc	EcmEMM_CONTROL,0
		goto	RetCode
		
i3cerror				;Error: borrar buffer con FF's
		movwf	DUMMY4	
		cbank10 ; 0
		movlw	0xff
		call	FillBuffer
		clrf	FSR2
		call	StoreBuffer8
		call	StoreBuffer8
		cbank01 
		movf	DUMMY4,w
		goto	RetCode

no_mhw
		clrf	FSR2
		call	FindNanoD1
		goto	TX90xx
;**************************************************************************************************
; Ins 40 : ENTITLEMENT MANAGEMENT
; key must be 0-B
;**************************************************************************************************
Instr_40		
		call	Chk_Key			;comprobamos la primaria
		movwf	DUMMY1
		xorlw	(0x00)
		btfss	STATUS,Z		;if Key exist skip...
			goto	Next_ck_40
		bcf	IC_P1,4
		goto	KEY_ERROR		
Next_ck_40
		btfss	IC_P1,4
		goto	nocheck_40
		decf	DUMMY1,f
		btfsc	STATUS,Z
		goto	KEY_ERROR		;salimos con error
nocheck_40
		btfsc	IC_P2,3				;debe ser una MK
			goto	TX9013

Instr_40_2
		cbank10 ; 0
		clrw
		call	Decode
		call	CheckSignature
		cbank01 
		xorlw	(0x00)
		btfss   STATUS,Z
			goto    TX9002          ;Clave Falsa o Firma Inexistente

		bsf     LEDS,0          ;Activamos LED0 para indicar que ya hemos recibido anteriormente una 81 4e correcta

		call    ProcessNano
		xorlw	(0x00)
		btfss	STATUS,Z
			goto	RetCode

		btfsc	EcmEMM_CONTROL,4
			goto	TX9015
		btfsc	EcmEMM_CONTROL,6
			goto	TX9019
		btfsc	EcmEMM_CONTROL,7
			goto	TX97xx

		goto    TX9000

;**************************************************************************************************
; Ins 5A : encrypt null word
; if P2 bit4 is clear then encrypt null word with P1-P2 keys
; if P2 bit4 is set then we must be in ATR level 2 and previous ins 5C
; then initialize hash buffer with 5C word, encrypt with P1-P2 keys
; these are new keys to encrypt null word
;**************************************************************************************************
Instr_5A
		call	Chk_Key			;comprobamos la primaria
		movwf	DUMMY1
		xorlw	(0x00)
		btfss	STATUS,Z		;if Key exist skip...
			goto	Next_ck_5a
		bcf	IC_P1,4
		goto	KEY_ERROR		;...else goto Instr_5A_NOKey
Next_ck_5a
		btfss	IC_P1,4
		goto	nocheck_5a
		decf	DUMMY1,f
		btfsc	STATUS,Z
		goto	KEY_ERROR		;salimos con error
nocheck_5a
		btfsc	IC_P2,4			;if it's set ( xxx1 xxxx )...
			goto	P2_ERROR		;...send (8*ff) + 9402

		cbank10 ; 0
		call	ClearBuffer		;Initialize DW -> Buffer (8*00)
		call	Encrypt		;Encrypt
		movlw	BUFFER
		movwf	FSR
		movlw	0x08
		call	RAM_send
		cbank01 

		goto	TX9000

;**************************************************************************************************
Instr_02
		xgoto10	Instr_02b0

;**************************************************************************************************
Instr_04
		xgoto10	Instr_04b0


;**************************************************************************************************
; Ins 36 : output data requested and PPV event recording
; P1 : bit 5 must be set - provider must be the same of ins 38
; P2 : key for signature and for superencryption (if bit 7 is set)
; data from ins 38  ?=d1 ?=d2 ?=d3 ?=d4 ?=d5 ?=a1..a8
; d1 d2 d3
; 0  0  0    Provider package bitmap record   C1 36 xx yy 1D && 83 data 04 $$
; 1  0  0    Provider PPV credits record      C1 36 xx yy 1D && 84 data 04 $$
; 3  x  x    Provider PPV event record        C1 36 xx yy 20 && B1 data 04 $$
; 4  0  x    Seca record                      C1 36 20 yy 20 && B1 data 04 $$
; 6  x  x    Given record (number)            C1 36 xx yy 25 && D2 data 03 $$
; where:
; && = 86 a1..a8 if no probs or  FF a1..a8 if key problems
; $$ = 82 (signature) if no probs or nothing if key problems
;**************************************************************************************************
Instr_36
		movf	PREVINS,w
		xorlw	0x38
		btfss	STATUS,Z
			goto	PREVINS_ERROR
		movf	IC_P1,w
		andlw	0xE0
		xorlw	0x20
		btfss	STATUS,Z
		goto	TX9401
		movf	IC_P1,w
		andlw	0x0f
		xorwf	C38DATA+2,w
		btfss	STATUS,Z
		goto	TX9401
		btfsc	C34DATA,2
		goto	chk_3611c	;34- 4 0 0 y 6 0 0
		movlw	0x14		; Si len <=9 devolvemos nano 03
chk_36_cmp	subwf	IC_LEN,w
		bnc	EndRecord03
		goto	instr_36_good
chk_3611c	btfss	C34DATA,1
		goto	chk_36c
		movlw	0x1C		; Si len <=11 devolvemos nano 03
		goto	chk_36_cmp		
chk_36c		movlw	0x07		; Si len <=0c devolvemos nano 03
instr_36_good
		decf	IC_LEN,f
		clrf	FSR2
		movlw	0x86
		xcall10	Store
		movlw	0x08
		addwf	FSR2,f
		goto	i_34_len_ok

;**************************************************************************************************
; Ins 38 : data request and PPV event recording request
; C1 38 xx yy 1A  16 (d1) 2A (d2 d3) 2B (d4 d5) 86 (8 bytes) 82 (signature)
; Superencryption may be active
; on exit : ?=d1 ?=d2 ?=d3 ?=d4 ?=d5 ?=(8 bytes for security)
;           d1 d2 d3 as in ins 34   d4-d5 : PPV event date
;**************************************************************************************************
Instr_38
		bsf	LEDS,0
		clrf	NANOCNT
		movf	IC_P1,w
		andlw	0x0f
		movwf	C38DATA+2	;Guarda proveedor para siguiente 36
		movfw	IC_P2
		movwf	C38DATA
		call 	Chk_Key		;Si no encontrada P2 devuelve 901D
		xorlw (0x00)
		btfss	STATUS,Z
		goto	Ins_38_cont
		movfw	P1KEY
		movwf	IC_P1
		movfw	P2KEY
		movwf	IC_P2
Ins_38_cont
		cbank10 ; 0
		clrw
		btfsc	IC_P2,7
		call	Decode
		call	CheckSignature
		cbank01 
		xorlw	(0x00)
		btfss   STATUS,Z
		goto    TX9002          ;Clave Falsa o Firma Inexistente
		clrf	FSR2
		movfw	C38DATA
		movwf	IC_P2
		movfw	C38DATA+2
		movwf	IC_P1
		cbank10 ;	0
		call	Restore
		movwf	TEMP
		call	Restore
		movwf	C34DATA
		call	Restore
		movwf	TEMP+1
		call	Restore
		movwf	C34DATA+1
		call	Restore
		movwf	C34DATA+2
		call	Restore
		movwf	TEMP+2
		call	Restore
		movwf	C38DATA
		call	Restore
		movwf	C38DATA+1
		call	Restore
		movwf	TEMP+3
		cbank01 
		movfw	TEMP
		xorlw	0x16
		btfss	STATUS,Z
		goto	TX96XX
		movfw	TEMP+1
		xorlw	0x2A
		btfss	STATUS,Z
		goto	TX96XX
		movfw	TEMP+2
		xorlw	0x2B
		btfss	STATUS,Z
		goto	TX96XX
		movfw	TEMP+3
		xorlw	0x86
		btfss	STATUS,Z
		goto	TX96XX
		cbank10 ;	0
		call	LoadBuffer8
		call	Restore
		cbank01 
		xorlw	0x82
		btfss	STATUS,Z
		goto	TX96XX
		movlw	0x01
		movwf	FSR2
		xcall10	StoreBuffer8
		goto	TX9000


;**************************************************************************************************
; Ins 48 : altera los bits 4 y 5 del registro $80
; C1 48 00 00 01 (data byte, bit 4 and 5)
;
; P1, p2 y LEN ignorados
; Slo influyen en esta decisin los bits 4,5 de d1
;**************************************************************************************************
Instr_48
		xgoto10	Instr_48b0

;**************************************************************************************************
; Ins 4A : show ext[?] and ext[?]
; C1 4A 00 00 22
;**************************************************************************************************
Instr_4A
		xgoto10	Instr_4Ab0
;*********************************************
Instr_56
Instr_4C
Instr_50
Instr_54
		goto	TX9011

;**************************************************************************************************
; Ins 5C : give 8 bytes data for ins 56/5A
; C1 5C xx yy 08 (data)
;**************************************************************************************************
Instr_5C
		xgoto10	Instr_5Cb0

;**************************************************************************************************
; Ins 7C : Change I/O mode and set timing (for eeprom write)
; must be: len = 3
; if d1 <> ff then set only timing
; if d1 = ff and ATR = level 2 then set timing and I/O mode flag
; d2 and d3 define time delay
; must be: 3<d2<32 and e8<d3<c8
;**************************************************************************************************
Instr_7C
		xgoto10	Instr_7Cb0

;**************************************************************************************************
Instr_42
Instr_8A
		goto	PREVINS_ERROR


;****************************************************************************************
;INS Protegidas
;Instrucciones especiales de actualizacion
;**************************************************************************************************

Instr_0C
		xcall10	GetCommandData
		clrf	FSR2
		movfw	IC_LEN		;if IC_LEN <> 08 ...
		xorlw	(0x08)
		btfss	STATUS	,Z
			goto	TX6700		; ... send 6700
		cbank10 ; 0
		call	LoadBuffer8
		movlw	HIGH	(TarjetaUA-BASE_DATOS)
		movwf	EEADRH2
		movlw	LOW	(TarjetaUA)
		movwf	EEADR2
		call	UpdateMem8
		cbank01 
		goto	TX9000

Instr_20    
		xgoto10	Instr_20b0

Instr_22
		xgoto10	Instr_22b0

Instr_24    
		xgoto10	Instr_24b0

Instr_26
		xgoto10	Instr_26b0

;**************************************************************************************************
;* PROCESS NANO                                                                                   *
;**************************************************************************************************
ProcessNano
		clrf	FSR2
		bcf	CONTROL2,7
ProcessNano_loop
		clrf	DESCByte         
                movf        IC_LEN,W
                subwf        FSR2,W
                btfsc        STATUS,C
		goto 	fin_nano_event		;retlw	0x00	
		call	b1_Restore         ;Leemos Nano
		movwf	DUMMY1
		incf	NANOCNT,f

ProcessNano_continue
		btfss	IC_INS,6
			goto	ProcessNano_3C
		movfw	DUMMY1

		xorlw   (0x01 ^ 0x00)
		btfsc   STATUS,Z
			goto    Nano01          ;Nano 01 (Deshabilita nano_24)

		xorlw   (0x02 ^ 0x01)
		btfsc   STATUS,Z
			goto    Nano02          ;Nano 02 (Habilita nano_24)

		xorlw   (0x03 ^ 0x02)
		btfsc   STATUS,Z
			goto    Nano03          ;Nano 03 (Anula Pin)

		xorlw   (0x10 ^ 0x03)
		btfsc   STATUS,Z
			goto    Nano10          ;Nano 10 (Delete Key)

		xorlw   (0x11 ^ 0x10)
		btfsc   STATUS,Z
			goto    Nano11		;Nano 11 (Borra SECA Record Ex)
                
		xorlw   (0x17 ^ 0x11)
		btfsc   STATUS,Z
			goto    Nano17          ;Nano 17 (Cdigo de regin)

		xorlw   (0x21 ^ 0x17)
		btfsc   STATUS,Z
			goto    Nano21          ;Nano 21 (Fecha fin de abono)

		xorlw	(0x22 ^  0x21)
		btfsc	STATUS,Z
			goto	Nano22		;Nano22 (chequea fecha de abono)

		xorlw   (0x28 ^ 0x22)
		btfsc   STATUS,Z
			goto    Nano28          ;Nano 28 (Borra Ax, con los dos bytes)

		xorlw   (0x32 ^ 0x28)
		btfsc   STATUS,Z
			goto    Nano32          ;Nano 32 (Crea registro Bx)

		xorlw   (0x40 ^ 0x32)
		btfsc   STATUS,Z
			goto    Nano40          ;Nano 40 (Borra Bx rango)

		xorlw   (0x41 ^ 0x40)
		btfsc   STATUS,Z
			goto    Nano41          ;Nano 41 (Nueva PPUA)

		xorlw   (0x42 ^ 0x41)
		btfsc   STATUS,Z
			goto    Nano42          ;Nano 42 (Crea DX)

		xorlw   (0x43 ^ 0x42)
		btfsc   STATUS,Z
			goto    Nano42          ;Nan 43  (Nueva DX)

		xorlw   (0x90 ^ 0x43)
		btfsc   STATUS,Z
			goto    Nano90          ;Nano 90 (Nueva PK)

		xorlw   (0x91 ^ 0x90)
		btfsc   STATUS,Z
			goto    Nano91          ;Nano 91 (Nueva SK)

		xorlw   (0xB0 ^ 0x91)
		btfsc   STATUS,Z
			goto    NanoB0		;Nano B0 (Record)

		xorlw   (0xD0 ^ 0xB0)
		btfsc   STATUS,Z
			goto    NanoD0          ;Nano D0 (Nuevo Provider ID string)

		xorlw   (0xF0 ^ 0xD0)
		btfsc   STATUS,Z
			goto    NanoF0          ;Nano F0 (CUSTWP-Bitmap)

		xorlw   (0x80 ^ 0xF0)
		btfsc   STATUS,Z
		goto    Nano80		;Nano 80 (Nuevo PBM)

;-------------------------------------------------------------------------------
; Nanocommands for seca only
;-------------------------------------------------------------------------------
		xorlw   (0x23 ^ 0x80)
		btfsc   STATUS,Z
			goto    Nano23		;Nano 23 (Crea Proveedor)

		xorlw   (0x24 ^ 0x23)
		btfsc   STATUS,Z
			goto    Nano24		;Nano 24 (Usa Proveedor)

		xorlw   (0x25 ^ 0x24)
		btfsc   STATUS,Z
			goto    Nano25		;Nano 25 (Elimina Proveedor)

		xorlw   (0x26 ^ 0x25)
		btfsc   STATUS,Z
			goto    Nano26		;Nano 26 (Habilita modificacin registros)

		goto	ProcessNano_done

;************************************************************************************
; Nanos de la instruccion 3C
;************************************************************************************
ProcessNano_3C
		xgoto10	ProcessNano_3Cb0
ProcessNano_done                
		swapf   DUMMY1,W
		andlw   0x0F
		call	NanoLength
ProcessNano_next
		addwf   FSR2,F
		goto    ProcessNano_loop

;Devuelve el tamao del nano contenido en w
NanoLength	
		xorlw	(0x0D ^  0x00)
		btfsc	STATUS,Z
			retlw	0x10

		xorlw	(0x0E ^ 0x0D)
		btfsc	STATUS,Z
			retlw	0x18

		xorlw	(0x0F ^ 0x0E)
		btfsc	STATUS,Z
			retlw	0x20

		xorlw	0x0F
		return
fin_nano_event
		btfsc	IC_INS,6
		retlw	(0x00)
		xgoto10	Borra_salida_3c
FindNanoD1
                movf        IC_LEN,W
               subwf        FSR2,W
                btfsc        STATUS,C
		retlw	0x6f
		call	b1_Restore         ;Leemos Nano
		movwf	DUMMY1
		incf	NANOCNT,f
		xorlw	0xD1
		btfsc	STATUS,Z
		goto	DecryptNanoD1
		swapf	DUMMY1,w   
		andlw   0x0F
		call	NanoLength
		addwf   FSR2,F
		goto    FindNanoD1

;**************************************************************

DecryptNanoD1
		cbank10 ;	0
		call	LoadKeys
		call	LoadBuffer8
		call	Decrypt
		movf	FSR2,w
		movwf	DUMMY4
		clrf	FSR2
		call	StoreBuffer8
		movf	DUMMY4,w
		movwf	FSR2
		call	LoadBuffer8
		call	Decrypt
		movlw	0x08
		movwf	FSR2
		call	StoreBuffer8
		cbank01 
		btfss	EcmEMM_CONTROL,0
		retlw	0x00
		retlw	0x27		;Preview


;-------------------------------------------------------------------------------
; Nanocommand 01 : Disable nano 24 for provider in use ($IA_ANS+04h = FFh)
; [01] : no data
;
; posible respuesta:
; 9008 no aplicable si inhabilitado Nano_01	(bit7($NANO26Auth)=0)
;-------------------------------------------------------------------------------
Nano01
		call	LoadNano26_Aut

		btfss	BUFFER+0,7			;check if bit 7 of NANO26Auth is set
		retlw	0x08
		
		call	CalcProvAUTh
		addlw	0x02				;Offset de NANO 01/02 Authorization
        btfsc   STATUS,C
        incf    EEADRH2,f
		movwf	EEADR2
		movlw	0xFF
		movwf	BUFFER+0
		movlw	0x01
		xcall10	UpdateMem

		btfss	EcmEMM_CONTROL,5
			call	CalcNANOBitmap

		goto	ProcessNano_loop

;**************************************************************************************************
; Habilita nano_24 para el proveedor en uso	($IA_ANS+04h = 00h)
Nano02
		call	CalcProvAUTh
		addlw	0x02				;Offset de NANO 01/02 Authorization
        btfsc   STATUS,C
        incf    EEADRH2,f
		movwf	EEADR2
		clrf	BUFFER+0
		movlw	0x01
		xcall10	UpdateMem

		btfss	EcmEMM_CONTROL,5
			call	CalcNANOBitmap

		goto	ProcessNano_loop

;-------------------------------------------------------------------------------
; Nanocommand 03 : delete pin code
; 03 : no data
;-------------------------------------------------------------------------------
Nano03
		movlw	LOW(PIN)
		call	b1_Rd_eeprom
		movwf	DUMMY1          ;Primer byte del PIN
		movlw	LOW(PIN+1)
		call	b1_Rd_eeprom
		movwf	DUMMY2          ;Segundo byte del PIN

		iorwf DUMMY1,w
		btfsc STATUS,Z
		goto  ProcessNano_loop


ResetPIN
		cbank10 ; 0
		movlw	LOW	(PIN)
		movwf	EEADR2
		movlw	0x00
		call	Wr_eeprom
		incf	EEADR2,F
		movlw	0x00
		call	Wr_eeprom
		cbank01 

		goto	ProcessNano_loop

;-------------------------------------------------------------------------------
; Nanocommand 10 : delete given key (primary and secondary)
; [10] xx : key index
;-------------------------------------------------------------------------------
Nano10
		call	b1_Restore
		andlw	0x0F
		movwf	IC_P2

		call	ResetRegister	;Reset Primary Key register
		xcall10	FillRecord		;Fill Record with todas FF

		movfw	IC_P2
		addlw	0x10
		call	ResetRegister	;Reset Secondary Key register
		xcall10	FillRecord		;Fill Record with todas FF

		goto	ProcessNano_loop

ResetRegister
		cbank10 ; 0
		addlw	0x10			;Reset register of KEY RECORD
		movwf	REC2
		call	CalcProvRECORD
		movlw	0x00
		call	Wr_Memory
		cbank01 
		return

;-------------------------------------------------------------------------------
; Nanocommand 11 : delete seca record (Ex)
; [11] xx : type
;-------------------------------------------------------------------------------
Nano11
		movlw	0x01
		call	b1_LoadBuffer

		movfw	BUFFER+0
		xorlw	(0x00)
		btfsc	STATUS,Z
			goto	Delete_SECA_PPV
		xorlw	(0x01 ^ 0x00)
		btfsc	STATUS,Z
			goto	Delete_SECA_STARTUP
		xorlw	(0x02 ^ 0x01)
		btfsc	STATUS,Z
			goto	Delete_SECA_ACTIVATION

		goto	ProcessNano_loop

Delete_SECA_PPV
		movlw	SECA_PPVoffset
		goto	DeleteB0
Delete_SECA_ACTIVATION
		movlw	SECA_ACTIVATIONoffset
		goto	DeleteB0
Delete_SECA_STARTUP
		movlw	SECA_STARTUPoffset
DeleteB0
		call	ChkRECORD				;if record exist delete
		xorlw	(0x00)				;else continue ProcessNano processing
		btfss	STATUS,Z
			goto	ProcessNano_loop

		cbank10 ; 0
		call	FillRecord			;delete RECORD
		call	CalcProvRECORD		;reset REGISTER of RECORD
		movlw	0x00
		call	Wr_Memory
		cbank01 

		goto	ProcessNano_loop

		btfss	EcmEMM_CONTROL,5
			call	CalcNANOBitmap

		goto    ProcessNano_loop

;-------------------------------------------------------------------------------
; Nanocommand 17 : write regional bitmap
; [17] xx : regional bitmap
;
; escribe xx en $ProvID+18h
;
; Observaciones:
; Usado en NANO_F1 (no implementado)
;-------------------------------------------------------------------------------
Nano17
		cbank10 ; 0
		call	CalcProvAdr
		addlw	0x18			;Offset de cdigo de regin
        btfsc   STATUS,C
        incf    EEADRH2,f
		movwf	EEADR2
		btfsc	STATUS,C
			incf	EEADRH2,f
		movlw	0x01
		call	LoadBuffer
		movlw	0x01
		call	UpdateMem
		cbank01 

		btfss	EcmEMM_CONTROL,5
			call	CalcNANOBitmap

		goto	ProcessNano_loop


;-------------------------------------------------------------------------------
; Nanocommand 21 : set expiration date
; [21] xx xx : date
; pone fecha de abono ($ProvID+16/17h)
;-------------------------------------------------------------------------------
Nano21
		cbank10 ; 0
		call	UpdateDate
		cbank01 

		btfss	EcmEMM_CONTROL,5
			call	CalcNANOBitmap

		goto    ProcessNano_loop

;-------------------------------------------------------------------------------
; Nanocommand 22 : verify expiration date
; [22] xx xx : date
;-------------------------------------------------------------------------------
Nano22
		btfsc	CONTROLA,2
		goto	ProcessNano_next
		cbank10 ; 0
		call	CalcProvAdr
		addlw	0x16
		btfsc   STATUS,C
        	incf    EEADRH2,f
		call	Rd_Memory
		movwf	DUMMY3
		call	Rd_Memory_Next
		movwf	DUMMY4
		call	Restore
		movwf	DUMMY1
		call	Restore
		movwf	DUMMY2
		cbank01 
		Cmp16	DUMMY1,DUMMY2,DUMMY3,DUMMY4
		btfsc	STATUS,Z
		goto	Nano22_OK	;FECHA=FINABONO
		btfsc	STATUS,C
		retlw	0x31		;FECHA>FINABONO		
Nano22_OK				;FECHA<=FINABONO
		goto	ProcessNano_loop 

;-------------------------------------------------------------------------------
; Nanocommand 23 : add new provider
; for seca only
; [23] xx xx : provider ident
;
; posibles mensajes:
; 9005 nano aplicable slo a SECA
; 9018 el provedor ya existe
; 9019 numero maximo de registros actualizado
;	(al aumentar el num de prov disminuye)!!!
; 9006 no hay espacio para ms proveedores (max 16)
;-------------------------------------------------------------------------------
Nano23
		movf	IC_P1,f
		btfss	STATUS,Z
			retlw	0x05

		movlw	0x02
		call	b1_LoadBuffer

		movfw	BUFFER+1
		xcall10	ChkIDENT			;if provider exist send 9018
		xorlw	(0x00)
		btfsc	STATUS,Z
			retlw	0x18

		movlw	0xFF
		xcall10	ChkIDENT			;if provider exist send 9018
		xorlw	(0x00)
		btfss	STATUS,Z
			retlw	0x06			;send 9006, no hay espacio para ms proveedores (max 16)

		xcall10	ChkRECORDFree
		btfsc	CONTROL2,2
			retlw	0x19

		xcall10	NEW_PROVIDER

Update_I16_ANS
		movlw	LOW	(I16_ANS+2)
		movwf	EEADR2

		movfw	DUMMY1
		call	b1_Wr_Memory
		incf	EEADR2,f
		movfw	DUMMY2
		call	b1_Wr_Memory

		bsf	CONTROL2,7

		goto    ProcessNano_loop

;-------------------------------------------------------------------------------
; Nanocommand 24 : apply next nanos to given provider (if flag 24 = 0)
; for seca only
; [24] xx xx : provider ID
; Si existe y est habilitado queda fijado para los no_seca_nanos que le sigan.
;
; posibles mensajes:
; 9005 nano aplicable slo a SECA
; 9007 not allowed - provider blocked
;-------------------------------------------------------------------------------
Nano24
		movf	IC_P1,f
		btfss	STATUS,Z
			retlw	0x05

		movlw	0x02
		call	b1_LoadBuffer

		movf BUFFER+0,f
		btfss STATUS,Z
			retlw	0x04

		movfw	BUFFER+1
		xcall10	ChkIDENT
		xorlw	(0x00)
		btfss	STATUS,Z
			retlw	0x04
		xcall10	Chk_Provider
		btfss	STATUS,C		;if provider is active skip...
			retlw	0x04			;...else send STATUSBYTE 9004

;check if authorization of NANO 01/02 is activated
;if it isn't 00 send 9007

		call	CalcProvAUTh
		addlw	0x02				;Offset de NANO 01/02 Authorization
        btfsc   STATUS,C
        incf    EEADRH2,f
		call	b1_Rd_Memory
		xorlw	(0xFF)
		btfsc	STATUS,Z
			retlw	0x07		; else send 9007

		bsf	CONTROL2,7
		goto	ProcessNano_loop

;-------------------------------------------------------------------------------
; Nanocommand 25 : delete given provider
; for seca only
; [25] xx xx : provider ID
;
; Elimina todos los registros asociados al prov_id
;
; posibles mensajes:
; 9005 nano aplicable slo a SECA
;-------------------------------------------------------------------------------
Nano25						;Future implementation
		movf	IC_P1,f
		btfss	STATUS,Z
			retlw	0x05

		movlw	0x02
		call	b1_LoadBuffer

		xcall10	ChkIDENT
		xorlw	(0x00)
		btfss	STATUS,Z
			retlw	0x04

		xcall10	RESET_PROVIDER

		goto	Update_I16_ANS

		goto    ProcessNano_loop

;-------------------------------------------------------------------------------
; Nanocommand 26 : modify provider space for records and flags
; for seca only
; [26] xx xx : new value
; use after nano 24
;
; posibles mensajes:
; 9005 nano aplicable slo a SECA
;-------------------------------------------------------------------------------
Nano26
		btfsc	CONTROL2,7
			goto	Nano26_2

		movf	IC_P1,f
		btfss	STATUS,Z
			retlw	0x05

Nano26_2
		movlw	0x02
		call	b1_LoadBuffer
		call	CalcProvAUTh
		movwf	EEADR2
		movlw	0x02
		xcall10	UpdateMem

		btfss	EcmEMM_CONTROL,5
			call	CalcNANOBitmap

		goto    ProcessNano_loop

;-------------------------------------------------------------------------------
; Nanocommand 28 : borra Ax 
; [28] xx xx  : fecha del registro AX
;
;-------------------------------------------------------------------------------
Nano28
		cbank10 ;	0
		movfw	nano27DATE
		movwf	DUMMY1
		movfw	nano27DATE+1
		movwf	DUMMY2
		call	Restore
		movwf	nano27DATE
		call	Restore
		movwf	nano27DATE+1
		call	del_ax_reg
		movfw	DUMMY1
		movwf	nano27DATE
		movfw	DUMMY2
		movwf	nano27DATE+1
		cbank01 
		goto	ProcessNano_loop
;-------------------------------------------------------------------------------
; Nanocommand 32 : seek or create record for a given event-id
; INS_40 Crea registro Bx
; 32 xx xx xx : event-id (2 bytes) and vision number
;
; posibles mensajes:
; 9003 Superado numero maximo de registros
; 98XX Si d1=d2 = 00 (xx numero de nanos procesados)
; 9015 Si no habilitado cracin/modificacin de registros ( nano 26)
;-------------------------------------------------------------------------------
Nano32
		call	LoadNano26_Aut
		btfsc	BUFFER+0,2			;Check bit 2
			goto	Nano32next

		bsf	EcmEMM_CONTROL,4		;Send 9015 before ProcessNano done
		movlw	0x03
		goto	ProcessNano_next

;Initialize Buffer of RECORD
Nano32next
		cbank10 ; 0
		call	InitRECORDBuffer		;Clear BUFFER[00..0B]

		call	Restore
		movwf	BUFFER+1
		call	Restore
		movwf	BUFFER+2
		call	Restore
		movwf	BUFFER+4

		movlw	0xFF
		movwf	BUFFER+3
		movwf	BUFFER+7
		movwf	BUFFER+8
		movfw	IC_P1
		andlw	0x0F
		iorlw	0xB0
		movwf	BUFFER+0B
		cbank01 

;if EVENT ID is 00 00 skip nano 32 processing and continue with ProcessNano_loop

		movf	BUFFER+2,f
		btfss	STATUS,Z
			goto	Continue
		movf	BUFFER+1,f
		btfsc	STATUS,Z
			goto	ProcessNano_loop

; se il record esiste SEND 9000 altrimenti scrivi un nuovo record
Continue
		call	CheckBx
		xorlw	(0x00)
		btfsc	STATUS,Z
			retlw	0x00
NewBx
		xcall10	ChkRECORDFree
		btfsc	CONTROL2,2
			retlw	0x03		;Superado numero maximo de registros (9003)
		cbank10 ; 0
		call	CalcRECORDAdr		;EEADRH2:EEADR2 Address of first record free
		movlw	0x0C
		call	UpdateMem
		cbank01 

		goto    ProcessNano_loop


;-------------------------------------------------------------------------------
; Nanocommand 40 : delete ppv event records with event-id between min-max
; INS_40 Borra Bx rango
; [40] xx xx yy yy : minimum and maximum
;-------------------------------------------------------------------------------
Nano40
		movlw	0x04
		call	b1_LoadBuffer
		call	nano_2d_3c
		goto    ProcessNano_loop

nano_2d_3c	movfw	IC_P1
		andlw	0x0F
		iorlw	0xB0
		xcall10	SearchRECORD
Nano40_loop
		btfsc	CONTROL2,2
		return
		xcall10	CalcRECORDAdr
		incf	EEADR2,f
		btfsc	STATUS,Z
		incf	EEADRH2,f
		movfw	EEADR2
		call	b1_Rd_Memory
		movwf	DUMMY3
		xcall10	Rd_Memory_Next	
		movwf	DUMMY4
		Cmp16	DUMMY3,DUMMY4,BUFFER,BUFFER+01
		btfss	STATUS,C
		goto	Nano40_next		
		Cmp16	BUFFER+02,BUFFER+03,DUMMY3,DUMMY4
		btfss	STATUS,C
		goto	Nano40_next
		movfw	REC3
		xcall10	FillRecord
Nano40_next	xcall10	SearchRECORD_next
		goto	Nano40_loop

;-------------------------------------------------------------------------------
; Nanocommand 41 : set PPUA
; [41] xx xx xx xx : PPUA
; se escribe la PPUA ($Prov_ID+12h)
;-------------------------------------------------------------------------------
Nano41
		cbank10 ; 0
		call	CalcProvAdr
		addlw	0x12            ;Offset de la PPUA
        btfsc   STATUS,C
        incf    EEADRH2,f
		movwf	EEADR2
		btfsc	STATUS,C
			incf	EEADRH2,f
		movlw	0x04
		call	LoadBuffer
		movlw	0x04
		call	UpdateMem
		cbank01 

		btfsc	EcmEMM_CONTROL,5
			goto	Nano41_ok
		call	CalcNANOBitmap
		goto	ProcessNano_loop

Nano41_ok
		bsf	EcmEMM_CONTROL,6		;Next call to STATUSBYTE send 9019
		goto    ProcessNano_loop

;**************************************************************************************************
; Nano_42
; INS_40 Crea registro Dx
;
; [32] d1 d2 d3 d4
; Crea el registro Dx
; donde:
; d1 d2 = nmero de fichas
; d3 d4 = fecha de actualizacin
;
; posibles mensajes:
; 9003 Superado numero maximo de registros
; 98XX Si d1=d2 = 00 (xx numero de nanos procesados)
; 9015 Si no habilitado cracin/modificacin de registros ( nano 26)

Nano42
		xcall10	nano42_b0
		xorlw	(0x03)
		btfsc	STATUS,Z
			retlw	0x03
		goto	ProcessNano_loop


;-------------------------------------------------------------------------------
; Nanocommand 90 : write primary key [8x]
; [90] (9 bytes data) : index and key
;-------------------------------------------------------------------------------
Nano90
		bcf 	CONTROL2,0			;Primary Key
ProcessNano90y91
		xcall10   UpdateKey

		btfss	EcmEMM_CONTROL,5
			call	CalcNANOBitmap

		goto    ProcessNano_loop

;-------------------------------------------------------------------------------
; Nanocommand 91 : write secondary key [Cx]
; 91 (9 bytes data) : index and key
;-------------------------------------------------------------------------------
Nano91
		bsf 	CONTROL2,0			;Secondary Key
		goto	ProcessNano90y91

;**************************************************************************************************
; Nano_B0
; INS_40 Crea SECA record Ex
;
; [B0] d1....d11
; escribe un seca record con indice d1

NanoB0
		movlw	0x0B
		call	b1_LoadBuffer

		movf	IC_P1,f			;Only for PROVID 0000 ( SECA )
		btfss	STATUS,Z
			goto	NanoB0_end

		bsf	DESCByte,2			;Next call to NewRecord write a Bx record

		movfw	BUFFER+0
		xorlw	(0x00)
		btfsc	STATUS,Z
			goto	NanoB0_SECA_PPV
		xorlw	(0x01 ^ 0x00)
		btfsc	STATUS,Z
			goto	NanoB0_SECA_STARTUP
		xorlw	(0x02 ^ 0x01)
		btfsc	STATUS,Z
			goto	NanoB0_SECA_ACTIVATION

NanoB0_end
		goto	ProcessNano_loop

NanoB0_SECA_PPV
		movlw	SECA_PPVoffset
		goto	WriteB0
NanoB0_SECA_ACTIVATION
		movlw	SECA_ACTIVATIONoffset
		goto	WriteB0
NanoB0_SECA_STARTUP
		movlw	SECA_STARTUPoffset
WriteB0
		call	ChkRECORD
		cbank10 ; 0
		xorlw	(0x00)
		btfss	STATUS,Z
		call	NewRecord
		call	CalcRECORDAdr
		movlw	0x0B
		call	UpdateMem
		cbank01 

		goto	ProcessNano_loop

;-------------------------------------------------------------------------------
; Nanocommand D0 : change provider name ($prov_id+2)
; [D0] (16 data bytes) : new provider name
;-------------------------------------------------------------------------------
NanoD0
		cbank10 ; 0
		call	CalcProvAdr
		addlw	0x02            ;Offset de ID string
        btfsc   STATUS,C
        incf    EEADRH2,f
		movwf	EEADR2
		btfsc	STATUS,C
			incf	EEADRH2,f
		call	LoadBuffer8
		call	UpdateMem8
		call	LoadBuffer8
		call	UpdateMem8
		cbank01 

		btfss	EcmEMM_CONTROL,5
			call	CalcNANOBitmap

		goto    ProcessNano_loop

;-------------------------------------------------------------------------------
; Nanocommand F0 : verify CUSTWP
; [F0] (20h bytes data) : customer word pointer bitmap
;-------------------------------------------------------------------------------
NanoF0
                movfw        FSR2
                addlw        0x20
                movwf        DUMMY3                        
                xcall10        CalcProvAdr
		btfss	IC_INS,6
		addlw	0x03
                addlw        0x15
		btfsc STATUS,C
		incf EEADRH2,f
                call        b1_Rd_Memory        ;Leemos el ltimo byte de la PPUA
                movwf        DUMMY1
		btfss	IC_INS,6
		goto	F1_3c
                btfsc CONTROL,5
                goto        Correct_UA
F1_3c           call Check_UA
                btfsc        STATUS,C
		goto Correct_UA

Incorrect_UA
		btfsc	IC_INS,6
                retlw        0x09                        ;Si la tarjeta no est direccionada devolver 9009 
		retlw	0x35
Correct_UA
                movfw        DUMMY3
                movwf        FSR2
                goto        ProcessNano_loop

;********************************************************************************
Check_UA
		movwf	DUMMY2
		andlw	0x07
		movwf	COUNTER			;Alcanenamos el Offset del byte
		rrf	DUMMY2,F
		rrf	DUMMY2,F
		rrf	DUMMY2,W
		andlw	0x1F
		subwf	DUMMY3,W
		movwf	FSR2
		decf	FSR2,f				
		call	b1_Restore				
		movwf	DUMMY2
		incf	COUNTER,F
CheckUA_loop				
		rrf	DUMMY2,F
		decfsz	COUNTER,F
		goto	CheckUA_loop
        	return

;-------------------------------------------------------------------------------
; Nanocommand 80 : set provider bitmap package
; 80 (8 bytes data) : bitmap package
;-------------------------------------------------------------------------------
Nano80
		btfsc       CONTROL,4
                goto        nano80_prot
                call        LoadNano26_Aut
                btfsc       BUFFER+0,4
                goto        Check_PBM
Nano80_end
                bsf        EcmEMM_CONTROL,4                ;Send 9015 alla fine del ProcessNano
                movlw        0x08
                goto        ProcessNano_next
Check_PBM
                movlw	    0x08
                movwf       COUNTER                         ; inicializo el contador
                xcall10       CalcPBMAdr
                movfw       REC3
                xorlw       (0x00)
                btfss       STATUS,Z
                goto        nano80_continue
                bsf         DESCByte,1
                cbank10 ; 0
                call        NewRecord
                call        CalcPBMAdr
                cbank01 
nano80_continue
                cbank10 ; 0
                call        LoadBuffer8
                call 	    UpdateMem8
                cbank01         
		btfss       EcmEMM_CONTROL,5
nano80_prot	call        CalcNANOBitmap
                goto        ProcessNano_loop

;****************************************************************************
;this routine store in BUFFER+0 y BUFFER+1 the value of NANO 26 Authorization
LoadNano26_Aut
		call	CalcProvAUTh
		movwf	EEADR2
		cbank10 ; 0
		call	Rd_Memory
		movwf	BUFFER+0
		call	Rd_Memory_Next
		movwf	BUFFER+1
		cbank01 
		return

;****************************************************************************
; Calcula el offset en la eeprom externa del authorization del proveedor especificado en IC_P1
; Devuelve en EEADRH2:W
CalcProvAUTh
		xcall10	CalcProvAdr
		addlw	NANO26offset
		btfsc	STATUS,C
			incf	EEADRH2,f
		return

;*******************
; Check Key Routine
;*******************
Chk_Key
		movfw	IC_P2
		andlw	0x0F
		addlw	PKEYSoffset
		call	ChkRECORD
		xorlw	(0x00)
		btfss	STATUS,Z
		retlw	(0x00)		
		btfss	IC_P1,4			;if it's set ( xxx1 xxxx )....
		goto	Chk_key_load_1
		movfw	IC_P2
		andlw	0x0F
		addlw	SKEYSoffset
		call	ChkRECORD
		xorlw	(0x00)
		btfss	STATUS,Z
		goto	Chk_key_load_1
		xcall10	LoadKeys
		retlw	0x02
Chk_key_load_1
		xcall10	LoadKeys
		retlw	0x01
;-----------------------------------------
; Check if RECORD specified in Register W exist
; if exist return 0x00 else return 0x02 if doesn't exist
ChkRECORD
		movwf	REC2
		xcall10	CalcProvRECORD
		movfw	REC3
		xorlw	(0x00)
		btfsc	STATUS,Z
			retlw	0x02
		retlw	0x00

;This routine calculate NANOBitmap for STATUS BYTE 97xx
CalcNANOBitmap
		decf	NANOCNT,w
calcnnbmp	
		xcall10	GetBitMask
		iorwf	NANOBitmap,f	
salecalcnnbmp
		bcf	EcmEMM_CONTROL,5		;Deshabilita bit 5 (UPDATE Done)
		bsf	EcmEMM_CONTROL,7		;Habilita bit 7
		return
CheckBx
		movlw	0xFF
		movwf	BUFFER+0D
		movwf	BUFFER+0E
		movwf	BUFFER+0F
		movfw	IC_P1
		andlw	0x0F
		iorlw	0xB0
		xcall10	SearchRECORD
CheckBx_loop
		btfsc	CONTROL2,2
			retlw	0x02
		xcall10	CalcRECORDAdr
		incf	EEADR2,f
		btfsc	STATUS,Z
			incf	EEADRH2,f
		movfw	EEADR2
		call	b1_Rd_Memory
		movwf	DUMMY5
		xcall10	Rd_Memory_Next	;if second byte is egual TX9000
		movwf	DUMMY6
		Cmp16	DUMMY5,DUMMY6,BUFFER+1,BUFFER+2		
		btfss	STATUS,C
			goto	CheckBx_next1
		btfsc	STATUS,Z
			retlw	0x00
CheckBx_next	Cmp16	DUMMY5,DUMMY6,BUFFER+0D,BUFFER+0E
		btfsc	STATUS,C
			goto	CheckBx_next1
		movfw	REC3
		movwf	BUFFER+0F
		movfw	DUMMY5
		movwf	BUFFER+0D
		movfw	DUMMY6
		movwf	BUFFER+0E
CheckBx_next1
		xcall10	SearchRECORD_next
		goto	CheckBx_loop

;-------------------------------------------------------------------------------
; STATUS CODES
;
; 01 01  ram error (address 01-fb)
; 01 02  ram error (address fc-ff)
; 01 xx  rom error (xx = Kbyte with checksum error + #10h, so 10,11,...,20)
; 67 00  data buffer overflow, len out of range (>5F), len 0 with ins bit 1 set,
;        ins 7c len error, ins 0C P2=0-1 len error, len error ins 04, len error
;        ins 30, len error ins 34-36, len error ins 4C, len error ins 42/8A
; 6D 00  invalid ins (ins bit 0 set), ins permitted only in atr level 2
;        ins not found
; 6E 00  not C1 command
; 90 01  error writing eeprom
; 90 02  signature incorrect
; 90 03  not enought space (for records) for given provider
; 90 04  provider doesn't exist
; 90 05  nanocommand for seca only (ins 40)
; 90 06  free record not found, all 15 provider used
; 90 07  nano 24 flag disabled
; 90 08  ins 40 nano 01 flag disabled
; 90 09  CUSTWP error (ins 40 nano F0)
; 90 10  pin error
; 90 11  ins protected (unlock protection flag)
; 90 13  not a management key (ins 40)
; 90 14  previous ins not 04 (ins 02), previous ins error (ins 32/36)
;        previous ins not 3C (ins 3A), previous ins not 06 (ins 40 nano 87)
;        previous ins not 5C (ins 56-5A), previous ins incorrect (ins 42/8A)
; 90 15  ins 32/36 parameter d1 error, ins 3C nano 2C ppv tokens management flag
;        not set, ins 3C nano 15 flag not set, ins 40 nano 80 flag not set,
;        ins 40 nano 32 flag not set, ins 40 nano 42 flags error
; 90 16  control data error (ins 40 nano 87 and ins 44)
; 90 17  ins 50-54-56 locked
; 90 18  provider already exists
; 90 19  ins 40 nano 23 new provider created, ins 40 nano 25 provider deleted
; 90 1A  ins 3C nano 31 ppv error, ins 3C nano 2C ppv error, ins 3C nano 15 ppv
;        error
; 90 1B  ppv credits record not found, not enough credits for event buying
; 90 1C  ppv tokens ended (ins 3C nano 2C)
; 90 1D  primary key not found
; 90 1E  ppv credits overflow (ins 40 nano 43)
; 90 1F  secondary key not found
; 90 20  ins 44 nano 90/91 key error
; 90 21  key is not key F (ins 04)
; 90 22  bit 7 of key index is set (ins 40 in atr 2)
; 90 23  ins 44 nano D1: nano 71 must be before nano D1
; 90 24  ins not allowed in atr level 3
; 90 25  ins 44 nano D1 service record counter is zero
; 90 26  ins 3C nano 31 ppv event already seen (no vision)
; 90 27  ins 3C nano 19 preview channel
; 90 28  key checksum incorrect
; 90 90  eeprom not updated (ins 40)
; 90 A0  eeprom updated (ins 40)
; 93 01  ins 3C nano 27 expiration date crossed, ins 40 nano 22 expiration
;        date crossed
; 93 02  ins 3C nano D1 no decryption
; 93 04  ins 3C nano 12 vision protected
; 93 05  ins 3C nano F0 vision not allowed for current region
; 94 01  ins 36 error in parameter P1
; 94 02  ins 0C error in parameter P2, ins 30 error in parameter P2, ins 32
;        error in parameter P2, ins 5A not in ATR level 2
; 96 00  ins 0C P2=1 nano 23-90 absent, ins 38 nano incorrect, ins 3C nano 82
;        nano problems, inc 3C nano 2C null event, ins 3C nano 15 null event
; 96 xx  ins 3C nano D1 not found (xx nanocommands encountered)
;        ins 40 length overflow (xx nanocommands encountered)
; 97 00  eeprom unaltered (no write)
; 98 01  ins 7C parameters out of range
; 98 xx  ins 40 nano 32 null event (xx nanocommands encountered)
; 99 xx  ins 40 nano 42 and 30 invalid date (xx nanocommands encountered)
; 9A 00  ins 56 key uncorrect
; 9A xx  ins 44 nano locked (xx nanos encountered)
;-------------------------------------------------------------------------------
RetCode
TX90xx
		bcf	LEDS,1
		movwf	DUMMY4
		btfsc	IC_INS,1
		call	b1_Send_FF

		movf	DUMMY4,w
		sublw	0x2f
		btfsc	STATUS,C
			goto	ret90xx
		
		swapf	DUMMY4,w
		andlw	0x0f
		xorlw	0x06
		btfsc	STATUS,Z
			goto	ret96xx
		xorlw	0x06^0x07
		btfsc	STATUS,Z
			goto	ret97xx
		xorlw	0x07
		addlw	0x90
		call	b1_Send
		bsf	CONTROL2,1
		movf	DUMMY4,w
		andlw	0x0f
			goto	SendMain
ret90xx
		movlw	0x90
		call	b1_Send
		movf	DUMMY4,w
		btfss	STATUS,Z
		bsf	CONTROL2,1
			goto	SendMain
ret96xx
		bsf	LEDS,1
		movlw	0x96
		call	b1_Send
		movf	DUMMY4,w
		andlw	0x0f
		xorlw	0x0f
		btfsc	STATUS,Z
		goto	retnanocnt
		xorlw	0x0f
			goto SendMain
retnanocnt
		movfw	NANOCNT
			goto	SendMain
ret97xx
		movlw	0x97
		call	b1_Send
		movf	NANOBitmap,w
			goto	SendMain

TX6700					;Incorrect length
		movlw	0x67
		bsf	CONTROL2,1
		goto	TXxx00
TX6D00					;Instruction not supported/valid or Instruction protected
		movlw	0x6D
		bsf	CONTROL2,1
		goto	TXxx00

TX9000 		
		clrw
		goto	TX90xx

TX9002					;Wrong or missing signature
		movlw	0x02
		goto	TX90xx
TX9003	
		movlw	0x03
		goto	TX90xx

PROV_ERROR	;Provider not supported
		movlw	0x04
		goto	TX90xx
TX9010					;Wrong PIN
		movlw	0x10
		goto	TX90xx
TX9011					;Testbit not set, Instruction not supported
		movlw	0x11
		goto	TX90xx
TX9013					;MK needed
		movlw	0x13
		goto	TX90xx

PREVINS_ERROR
TX9014					;Prev. ins error
		movlw	0x14
		goto	TX90xx
TX9015					;Nano not allowed for or Unsupported input value
		movlw	0x15
		goto	TX90xx
TX9019					;PPUA changed
		movlw	0x19
		goto	TX90xx

KEY_ERROR
		btfsc	IC_P1,4			;if it's set ( xxx1 xxxx )....
		goto	TX901F			;...send 901F
TX901D					;Primary Key not found
		movlw	0x1D
		goto	TX90xx
TX901F					;Secondary Key not found
		movlw	0x1F
		goto	TX90xx
TX9021					;Key is not 0F - Rejected
		movlw	0x21
		goto	TX90xx
TX9301					;Card has expired
		movlw	0x31
		goto	RetCode
TX9302					;No decoding
		movlw	0x32
		goto	RetCode
TX9304					;Parental guidance to low
		movlw	0x34
		goto	RetCode

TX9401					;Wrong P1 value
		movlw	0x41
		goto	RetCode
P2_ERROR	
TX9402					;Wrong P2 value
		movlw	0x42
		goto	RetCode
TX96XX		
		movlw	0x6f		;XX nanos processed fine, no nano 0xD1 found or All nanos were processed fine
		goto	RetCode
TX97xx		
		movlw	0x70		;Updating the EEPROM was not necessary for some nanos - bitmap xx
		goto	RetCode
TX9801
		movlw	0x81
		goto	RetCode		
;****************************************************************************************
; Rutina que enva al almacen de log los datos enviados hacia la cam
;****************************************************************************************
sed_log_end
                movlw   LOW(LOGCOUNTER+1)
                movwf   EEADR2
		movf	LDUMMY7,W
                call    b1_Wr_eeprom
		movfw	LEEADR2
		movwf	EEADR2
                movfw   LEEADRH2
                movwf   EEADRH2
		movfw	CONTROL3
		bsf	CONTROL3,0
		xgoto10	send_ret

Log
		btfss   CONTROLA,4	;Log activo?
			return
		btfss	CONTROL,2	;Log solo con eeprom externa
			return
		movlw	LOW(LOGCOUNTER)
		call	b1_Rd_eeprom                   
		movwf	DUMMY4
		movwf	DUMMY6
		movlw	LOW(LOGCOUNTER+1)                          
		call	b1_Rd_eeprom                   
		movwf	DUMMY3
		movwf	DUMMY5
		movf	IC_LEN,f
		btfss	STATUS,Z
		incf	DUMMY5,f
		movlw	LOW(MAXLOG)                          
		call	b1_Rd_eeprom
		movwf	DUMMY2
		movlw	LOW(MAXLOG+1)                          
		call	b1_Rd_eeprom
		movwf	DUMMY1
	
		movlw	0x05
		btfss	IC_INS,1
		addwf	IC_LEN,W
		addwf	DUMMY5,F
		btfsc   STATUS,C
		incf	DUMMY6,F           
		movf   	DUMMY2,W
		subwf  	DUMMY6,W                        
		btfss	STATUS,Z
		goto    Full_log
		movf	DUMMY1,W                        
		subwf   DUMMY5,W                        
Full_log	btfsc	STATUS,C
		goto	Log_full              

		movlw	0x04
		movwf	COUNTER
		movlw	IC_CLA
		movwf	FSR
		movlw   LOW(CONFIGLOG)  ;Comprueba la mscara
		movwf	DUMMY2
LogMaskLoop
		movf	DUMMY2,w
		call    b1_Rd_eeprom
		movwf   DUMMY1
		movf    INDF,W
		andwf   DUMMY1,F
		incf	DUMMY2,f
		movf	DUMMY2,w
		call    b1_Rd_eeprom
		xorwf   DUMMY1,W
		btfss   STATUS,Z
		return
		incf	FSR,f
		incf	DUMMY2,f
		decfsz	COUNTER,f
		goto	LogMaskLoop

                movf	DUMMY2,w
		call    b1_Rd_eeprom       ;Leer Longitud mxima
		subwf   INDF,w
		btfsc   STATUS,Z
		goto    Check_min
		btfsc   STATUS,C
		return
Check_min
		incf	DUMMY2,f
		movf	DUMMY2,w
		call    b1_Rd_eeprom       ;Leer Longitud mnima
                subwf   INDF,w
                btfss   STATUS,C
                return

		bsf	CONTROL3,0
                movlw   LOW(POSLOG+1)
                call    b1_Rd_eeprom
                addwf   DUMMY3,W
		btfsc   STATUS,C
		incf	DUMMY4,F
                movwf   EEADR2
                movlw   LOW(POSLOG)
                call    b1_Rd_eeprom
		addwf	DUMMY4,W
                movwf   EEADRH2

                bsf     LEDS,2          ;Led de datos en log
                movlw   IC_CLA
                movwf   FSR
Log_loop1    
                movf    INDF,W
                call    StoreLog
                incf    FSR,f
                btfsc   FSR,3
                goto    Log_loop1
                btfsc   IC_INS,1      ;Si es from CARD to CAM termino
                goto    End_Log

                clrf    FSR2
                movf    IC_LEN,W
                movwf   COUNTER
Log_loop2   
                call    b1_Restore         ;Datos
                call    StoreLog
                decfsz  COUNTER,f
                goto    Log_loop2

;**************************************************************************
End_Log         
		movf	IC_LEN,f
		btfsc	STATUS,Z
		goto	End_Log_1
		movfw	IC_INS
		call	StoreLog
End_Log_1
                movlw   LOW(LOGCOUNTER)
                movwf   EEADR2
		movf	DUMMY6,W
		movwf	LDUMMY8
                call    b1_Wr_eeprom
                movlw   LOW(LOGCOUNTER+1)
                movwf   EEADR2
		movf	DUMMY5,W
		movwf	LDUMMY7
                call    b1_Wr_eeprom
                return

StoreLog
                call    b1_Wr_Memory
                incf    EEADR2,F
                btfss   STATUS,Z
                return
                incf    EEADRH2,F
                return

Log_full
                bsf     LEDS,3          ;Led de Log lleno
                return
;****************************************************************************************
; Stubs para las rutinas generales en el banco de memoria 0 y otras rutinas en el banco 1 
;****************************************************************************************
		errorlevel -306
b1_Send
		bcf	PCLATH,3
		call	Send
                bsf     PCLATH,3
		return
b1_ChkSend
                bcf     PCLATH,3
		call	ChkSend
                bsf     PCLATH,3
		return
b1_Rd_eeprom
                bcf     PCLATH,3
		call	Rd_eeprom
                bsf     PCLATH,3
		return
b1_Restore
                bcf     PCLATH,3
		call	Restore
                bsf     PCLATH,3
		return
b1_Wr_Memory
                bcf     PCLATH,3
		call	Wr_Memory
                bsf     PCLATH,3
		return
b1_Rd_Memory
                bcf     PCLATH,3
		call	Rd_Memory
                bsf     PCLATH,3
		return
b1_Send_FF
                bcf     PCLATH,3
		call	Send_FF
                bsf     PCLATH,3
		return
b1_LoadBuffer
                bcf     PCLATH,3
		call	LoadBuffer
                bsf     PCLATH,3
		return
b1_Wr_eeprom
                bcf     PCLATH,3
		call	Wr_eeprom
                bsf     PCLATH,3
		return
	
		errorlevel +306


;------------------------------------------------------------------------------------------------------------
		include "eeprom.inc"

;Tablas de desencriptacion SECA
		ORG 0x1DF8
Tabla12             
		bcf     PCLATH,0
		bsf     PCLATH,1        ;Tabla1 en 0x1E00
		bsf     PCLATH,2
		movwf   PCL             ;Absolute addressing
Tabla22         
		bsf     PCLATH,0     
		bsf     PCLATH,1        ;Tabla 2 en 0x1F00
		bsf     PCLATH,2
		movwf   PCL             ;Absolute addressing

		ORG 0x1E00
Tablas
;-------------------------------------------------------------------------------
; Seca Algorithm Table 1
;-------------------------------------------------------------------------------
                DT  0x2A,0xE1,0x0B,0x13,0x3E,0x6E,0x32,0x48,0xD3,0x31,0x08,0x8C,0x8F,0x95,0xBD,0xD0
                DT  0xE4,0x6D,0x50,0x81,0x20,0x30,0xBB,0x75,0xF5,0xD4,0x7C,0x87,0x2C,0x4E,0xE8,0xF4
                DT  0xBE,0x24,0x9E,0x4D,0x80,0x37,0xD2,0x5F,0xDB,0x04,0x7A,0x3F,0x14,0x72,0x67,0x2D
                DT  0xCD,0x15,0xA6,0x4C,0x2E,0x3B,0x0C,0x41,0x62,0xFA,0xEE,0x83,0x1E,0xA2,0x01,0x0E
                DT  0x7F,0x59,0xC9,0xB9,0xC4,0x9D,0x9B,0x1B,0x9C,0xCA,0xAF,0x3C,0x73,0x1A,0x65,0xB1
                DT  0x76,0x84,0x39,0x98,0xE9,0x53,0x94,0xBA,0x1D,0x29,0xCF,0xB4,0x0D,0x05,0x7D,0xD1
                DT  0xD7,0x0A,0xA0,0x5C,0x91,0x71,0x92,0x88,0xAB,0x93,0x11,0x8A,0xD6,0x5A,0x77,0xB5
                DT  0xC3,0x19,0xC1,0xC7,0x8E,0xF9,0xEC,0x35,0x4B,0xCC,0xD9,0x4A,0x18,0x23,0x9F,0x52
                DT  0xDD,0xE3,0xAD,0x7B,0x47,0x97,0x60,0x10,0x43,0xEF,0x07,0xA5,0x49,0xC6,0xB3,0x55
                DT  0x28,0x51,0x5D,0x64,0x66,0xFC,0x44,0x42,0xBC,0x26,0x09,0x74,0x6F,0xF7,0x6B,0x4F
                DT  0x2F,0xF0,0xEA,0xB8,0xAE,0xF3,0x63,0x6A,0x56,0xB2,0x02,0xD8,0x34,0xA4,0x00,0xE6
                DT  0x58,0xEB,0xA3,0x82,0x85,0x45,0xE0,0x89,0x7E,0xFD,0xF2,0x3A,0x36,0x57,0xFF,0x06
                DT  0x69,0x54,0x79,0x9A,0xB6,0x6C,0xDC,0x8B,0xA7,0x1F,0x90,0x03,0x17,0x1C,0xED,0xD5
                DT  0xAA,0x5E,0xFE,0xDA,0x78,0xB0,0xBF,0x12,0xA8,0x22,0x21,0x3D,0xC2,0xC0,0xB7,0xA9
                DT  0xE7,0x33,0xFB,0xF1,0x70,0xE5,0x17,0x96,0xF8,0x8D,0x46,0xA1,0x86,0xE2,0x40,0x38
                DT  0xF6,0x68,0x25,0x16,0xAC,0x61,0x27,0xCB,0x5B,0xC8,0x2B,0x0F,0x99,0xDE,0xCE,0xC5
;-------------------------------------------------------------------------------
; Seca Algorithm Table 2
;-------------------------------------------------------------------------------
                DT  0xBF,0x11,0x6D,0xFA,0x26,0x7F,0xF3,0xC8,0x9E,0xDD,0x3F,0x16,0x97,0xBD,0x08,0x80
                DT  0x51,0x42,0x93,0x49,0x5B,0x64,0x9B,0x25,0xF5,0x0F,0x24,0x34,0x44,0xB8,0xEE,0x2E
                DT  0xDA,0x8F,0x31,0xCC,0xC0,0x5E,0x8A,0x61,0xA1,0x63,0xC7,0xB2,0x58,0x09,0x4D,0x46
                DT  0x81,0x82,0x68,0x4B,0xF6,0xBC,0x9D,0x03,0xAC,0x91,0xE8,0x3D,0x94,0x37,0xA0,0xBB
                DT  0xCE,0xEB,0x98,0xD8,0x38,0x56,0xE9,0x6B,0x28,0xFD,0x84,0xC6,0xCD,0x5F,0x6E,0xB6
                DT  0x32,0xF7,0x0E,0xF1,0xF8,0x54,0xC1,0x53,0xF0,0xA7,0x95,0x7B,0x19,0x21,0x23,0x7D
                DT  0xE1,0xA9,0x75,0x3E,0xD6,0xED,0x8E,0x6F,0xDB,0xB7,0x07,0x41,0x05,0x77,0xB4,0x2D
                DT  0x45,0xDF,0x29,0x22,0x43,0x89,0x83,0xFC,0xD5,0xA4,0x88,0xD1,0xF4,0x55,0x4F,0x78
                DT  0x62,0x1E,0x1D,0xB9,0xE0,0x2F,0x01,0x13,0x15,0xE6,0x17,0x6A,0x8D,0x0C,0x96,0x7E
                DT  0x86,0x27,0xA6,0x0D,0xB5,0x73,0x71,0xAA,0x36,0xD0,0x06,0x66,0xDC,0xB1,0x2A,0x5A
                DT  0x72,0xBE,0x3A,0xC5,0x40,0x65,0x1B,0x02,0x10,0x9F,0x3B,0xF9,0x2B,0x18,0x5C,0xD7
                DT  0x12,0x47,0xEF,0x1A,0x87,0xD2,0xC2,0x8B,0x99,0x9C,0xD3,0x57,0xE4,0x76,0x67,0xCA
                DT  0x3C,0xFB,0x90,0x20,0x14,0x48,0xC9,0x60,0xB0,0x70,0x4E,0xA2,0xAD,0x35,0xEA,0xC4
                DT  0x74,0xCB,0x39,0xDE,0xE7,0xD4,0xA3,0xA5,0x04,0x92,0x8C,0xD9,0x7C,0x1C,0x7A,0xA8
                DT  0x52,0x79,0xF2,0x33,0xBA,0x1F,0x30,0x9A,0x00,0x50,0x4C,0xFF,0xE5,0xCF,0x59,0xC3
                DT  0xE3,0x0A,0x85,0xB3,0xAE,0xEC,0x0B,0xFE,0xE2,0xAB,0x4A,0xAF,0x69,0x6C,0x2C,0x5D


;******************************************************************************************************
;* Valores en la EEPROM INTERNA del 16F876
;******************************************************************************************************
			ORG	0x2100
; Configuracin
CONFIGBYTE	DATA    0x92 	;
; Dedicados a identificar la version ( 14 byte free )
PROG_INFO	DE		VersionProg
		DE		VER_MAJOR
		DE		VER_MINOR
		DE		VersionRev
		DE		HIGH	(DATE)
		DE		LOW	(DATE)

; Lista de comandos implementados
CmdList	DATA	0x0A,0x0E,0x7C,0x16,0x12,0x34,0x32,0x30,0x3A,0x3C,0x40,0x1A,0x5A
		DATA	0x02,0x04,0x36,0x38,0x42,0x48,0x4A,0x4C,0x50,0x54,0x56,0x5C,0x8A

			ORG	0x212E
; Pin
PIN		DATA    0,0
CONFIGEX	DATA	0x00,0x00,0x00,0x00	;CONTROLA, CONTROLB, CONTROLC, CONTROLD
SINGLEMASK	DATA	0x00,0x03	;Mascara para el modo "single"

;-------------------------------------------------------------------------------
; ATR bytes 
;-------------------------------------------------------------------------------
ATRDATA		DATA	0x3B
		DATA	0xF7,0x11,0x00,0x01,0x40,0x96
		DATA	0x54,0x30,0x04
		DATA	0x0E,0x6C,0xB6,0xD6			;atr level 1

ATRLen		EQU	$-ATRDATA

			ORG	0x2170
MAXLOG		DATA    0x04,0x00
CONFIGLOG	DATA    0xFF,0x00,0xFF,0x00,0xFF,0x00,0xFF,0x00,0xFF,0x00
LOGCOUNTER	DATA    0x00,0x00
POSLOG		DATA    0x0C,0x00

			ORG	0x2180
BAUDRATE	DATA	0x05			;9322 bps @ 3.579545 MHz
			ORG	0x2190
BITTBL		DT	0x01,0x02,0x04,0x08,0x10,0x20,0x40,0x80

			ORG	0x21A0

;-------------------------------------------------------------------------------
; Ascii string ins 0A (card version)
;-------------------------------------------------------------------------------

I0A_ANS		DATA		0x63,0x19,0x00,0xCA,0x15,0x2F,0x01,0x03
CHECK_EEPROM	DATA		0x00,0x00
CRC_ROM		DATA		0xF2,0x2F,0xC7,0xBA,0xFF,0x43,0x94,0xBD 
		DATA		0x03,0x41,0x17,0x8B,0xE4,0x16,0xE6,0xDC
		DATA	 	0xB0,0xC6,0xFF,0x35,0xB3,0x0D,0x31,0x6C
		DATA		0x5B,0xBD,0xCF,0x48,0x7B,0x9E,0x53,0xEC
S.O.ROM		DATA		0x28,0x43,0x29,0x43,0x41,0x4E,0x41,0x4C
		DATA		0x2B,0x31,0x39,0x39,0x34,0x2F,0x39,0x35
		DATA		0x2F,0x39,0x36,0x20,0x4E,0x75,0x6D,0x34,0x30,0x00

I0ALen		EQU	$-I0A_ANS


;******************************************************************************************************
		END
