;Rutinas de comunicacion serie y pausa
;Temporales utilizados:
; ChkSend, Send: 	TEMP4,5,6,7
; Receive:		TEMP4,5,6


		constant	T_SERIAL		=	0x1A
		constant	T_SEND_START	=	0x32
		constant	T_SEND_STOP		=	0x3E
		constant	T_RECEIVE_START	=	0x2D
		constant	T_RECEIVE_STOP	=	0x1D


	IFDEF	SIMMODE
;**************************************************************************************************
; Rutinas para utilizar depurando con el simulador de MPLAB.

;Receive: Colocar un estimulo de registro en la dir. Receive al registro W
Receive
		movwf	TEMP+4
		movwf	TEMP+6
		return

ChkSend
		movf	IC_LEN,f
		btfsc	STATUS,Z
		retlw	0x00
		decf	IC_LEN,f        

;Send: Colocar un trace point.
Send
		movwf	TEMP+6
		movwf	TEMP+7
		return
	ELSE
;**************************************************************************************************
;Envia el byte en W por el puerto de serie (RB7)
ChkSend
		movf	IC_LEN,f
		btfsc	STATUS,Z
			retlw	0x00
		decf	IC_LEN,f        
Send        	
		goto	log_send
send_ret	
		movwf   TXREG           ;Para el envio de trfico
		movwf   TEMP+6		;Guarda valor a mandar
		movlw	T_SEND_START	;Pausa entre caracteres +- 170 us configurable en cada decoder
		call    Pause			
		bcf     PORTB,7     	
		movlw   B'01111111'
		tris    PORTB        	;RB7 salida
		clrf    TEMP+7		;Resetea ChkSum (parity bit)
		movlw   0x08            ;1 start+7 bits datos a enviar
		movwf   TEMP+4         
send_loop   
		call    Std_pause    	;pausa a 9600 +-93us
		rrf     TEMP+6,f		;Pasa el bit de la derecha al carry
		rrf     TEMP+6,W		;En W el valor que esta en el carry por el RRF se queda en el bit 7 de W
		andlw   0x80		;Se deja solo ese bit
		xorwf   TEMP+7,f		;Calcular paridad
		xorwf   PORTB,W		;Con estos dos XOR se saca la senal por RB7 sin cambiar los otros puertos
		xorwf   PORTB,f
		decfsz  TEMP+4,f		;Repetir con todos los bits
		goto    send_loop
		call    Std_pause		;Envia bit de paridad (Even en este caso)
		movf    TEMP+7,W       	;Calcula la paridad par
		xorwf   PORTB,W
		xorwf   PORTB,f
		call    Std_pause	;Envia la paridad
		movlw   B'11111111'  	;
		tris    PORTB        	;RB7 entrada
		movlw	T_SEND_STOP         	;2 bit de stop
		goto    Pause        	
;**************************************************************************************************
Receive     
		btfsc   PORTB,7
			goto	Receive	;Esperamos el start bit
		movlw	T_RECEIVE_START	;Esperamos 1 bit+1/2 datos
		call    Pause
		movlw   0x09		;Recibir 8 bits datos+ 1 paridad
		movwf   TEMP+4
Receive_loop 
		bcf     STATUS,C
		btfsc   PORTB,7
			bsf     STATUS,C
		rrf     TEMP+6,f   
		call    Std_pause
		nop				;ajuste fino este bucle es menor que en el send
		nop
		decfsz  TEMP+4,f
		goto    Receive_loop
		rlf	TEMP+6,f		;Ignorar paridad		
		movlw	T_RECEIVE_STOP	;Recibir 1 bit, falta 1/2 bit para enviar el trafico
		call    Pause
		movf    TEMP+6,W	
		movwf   TXREG           ;Para el envio de trfico
		return
	ENDIF
;*****************************
Std_pause   
		movlw	T_SERIAL		;Pausa estndar para enviar/recibir con protocolo serie
Pause       
		movwf	TEMP+5          ;Hace una pausa del tiempo indicado en W
Pause_loop  
		decfsz	TEMP+5,f
		goto	Pause_loop
		retlw	0x00
